;Copyright (C) 1997-2001 ZSNES Team ( zsknight@zsnes.com / _demo_@zsnes.com )
;
;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either
;version 2 of the License, or (at your option) any later
;version.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

%include "macros.mac"

EXTSYM DSPMem
EXTSYM dspWptr

NEWSYM Spc700AsmStart

%include "cpu/regsw.mac"
%include "cpu/spcaddr.inc"

section .data

NEWSYM Voice0Disable, db 1         ; Disable Voice 0
NEWSYM Voice1Disable, db 1         ; Disable Voice 1
NEWSYM Voice2Disable, db 1         ; Disable Voice 2
NEWSYM Voice3Disable, db 1         ; Disable Voice 3
NEWSYM Voice4Disable, db 1         ; Disable Voice 4
NEWSYM Voice5Disable, db 1         ; Disable Voice 5
NEWSYM Voice6Disable, db 1         ; Disable Voice 6
NEWSYM Voice7Disable, db 1         ; Disable Voice 7

NEWSYM spcnumread, times 4 db 0
NEWSYM halted, dd 0
EXTSYM SpeedHack

; SPC 700 Emulation by _Demo_
; Version 2.0

; Little info on functions :
; Write byte : write al at [ebx]
; Read byte : read al from [ebx]

section .bss
NEWSYM spcRam, resb 10000h
section .data

ALIGN32

;NEWSYM spcRam,   times 65472 db 0FFh  ; Pointer to the SPC's RAM
;EXTSYM spcRam

; copy #1
; THE SPC ROM :)
;   db 0CDh,0EFh,0BDh,0E8h,000h,0C6h,01Dh,0D0h,0FCh,08Fh,0AAh,0F4h,08Fh,0BBh,0F5h,078h
;   db 0CCh,0F4h,0D0h,0FBh,02Fh,019h,0EBh,0F4h,0D0h,0FCh,07Eh,0F4h,0D0h,00Bh,0E4h,0F5h
;   db 0CBh,0F4h,0D7h,000h,0FCh,0D0h,0F3h,0ABh,001h,010h,0EFh,07Eh,0F4h,010h,0EBh,0BAh
;   db 0F6h,0DAh,000h,0BAh,0F4h,0C4h,0F4h,0DDh,05Dh,0D0h,0DBh,01Fh,000h,000h,0C0h,0FFh
;   db 0AAh,0BBh,0CCh,0DDh,0EEh,0FFh,000h,011h,022h,033h,044h,055h,066h,077h,088h,099h

;mapped spcA:spcY to dl:dh

NEWSYM spcPCRam,
         dd 0     ; Program Counter (with spcRam added)
NEWSYM spcA,
         db 0     ; The A register (general purpose)
         db 0
         db 0
         db 0
NEWSYM spcX,
         db 0     ; The X register (general purpose)
         db 0
         db 0
         db 0
NEWSYM spcY,
         db 0     ; The Y register (general purpose)
         db 0
         db 0
         db 0
NEWSYM spcP,
         db 0     ; The processor status byte (Removed for each flags)
         db 0     ; NZ are not always processed...
         db 0
         db 0
NEWSYM spcNZ,
         db 0     ; The processor NZ flag (little speed up hack :) )
         db 0
         db 0
         db 0


;spcNF    db 0     ; The Negative Flag  128 or 127
;spcOF    db 0     ; The Overflow Flag   64 or 191
;spcDPF   db 0     ; Direct Page Flag    32 or 223
;spcUF    db 0     ; The Unused Flag ?   16 or 239
;spcHCF   db 0     ; The Half Carry Flag  8 or 247
;spcIF    db 0     ; The interrupt flag   4 or 251
;spcZF    db 0     ; The Zero Flag        2 or 253
;spcCF    db 0     ; The Carry Flag       1 or 254

NEWSYM spcS,     dd 1FFh   ; The stack pointer (always from 100 to 1FF) (added Ram)
NEWSYM spcRamDP, dd 0     ; The direct page pointer 
;NEWSYM spcCycle, dd 0     ; The Cycle Counter
;NEWSYM reg1read, db 0     ; read from 65816
;NEWSYM reg2read, db 0     ; read from 65816
;NEWSYM reg3read, db 0     ; read from 65816
;NEWSYM reg4read, db 0     ; read from 65816
NEWSYM timeron,  db 0     ; timer0 on
NEWSYM timincr0, db 0     ; # of ticks before incrementing
NEWSYM timincr1, db 0     ; # of ticks before incrementing
NEWSYM timincr2, db 0     ; # of ticks before incrementing
NEWSYM timinl0,  db 0     ; ticks left before incrementing
NEWSYM timinl1,  db 0     ; ticks left before incrementing
NEWSYM timinl2,  db 0     ; ticks left before incrementing

section .bss
NEWSYM spcextraram, resb 64; extra ram, used for tcall
section .data


;spcsave equ $-spcRam
; pharos equ hack *sigh*

; copy #2
NEWSYM SPCROM
   db 0CDh,0EFh,0BDh,0E8h,000h,0C6h,01Dh,0D0h,0FCh,08Fh,0AAh,0F4h,08Fh,0BBh,0F5h,078h
   db 0CCh,0F4h,0D0h,0FBh,02Fh,019h,0EBh,0F4h,0D0h,0FCh,07Eh,0F4h,0D0h,00Bh,0E4h,0F5h
   db 0CBh,0F4h,0D7h,000h,0FCh,0D0h,0F3h,0ABh,001h,010h,0EFh,07Eh,0F4h,010h,0EBh,0BAh
   db 0F6h,0DAh,000h,0BAh,0F4h,0C4h,0F4h,0DDh,05Dh,0D0h,0DBh,01Fh,000h,000h,0C0h,0FFh


NEWSYM SPCCycleTable

dd 2, 8, 4, 5, 3, 4, 3, 6, 2, 6, 5, 4, 0, 4, 6, 8
dd 2, 8, 4, 5, 4, 5, 5, 6, 5, 5, 6, 5, 2, 2, 4, 6
dd 2, 8, 4, 5, 3, 4, 3, 6, 2, 6, 5, 4, 5, 4, 5, 4
dd 2, 8, 4, 5, 4, 5, 5, 6, 5, 5, 6, 5, 2, 2, 3, 8
dd 2, 8, 4, 5, 3, 4, 3, 6, 2, 6, 4, 4, 5, 4, 6, 6
dd 2, 8, 4, 5, 4, 5, 5, 6, 5, 5, 4, 5, 2, 2, 4, 3
dd 2, 8, 4, 5, 3, 4, 3, 6, 2, 6, 4, 4, 5, 4, 5, 5
dd 2, 8, 4, 5, 4, 5, 5, 6, 5, 5, 5, 5, 2, 2, 3, 6
dd 2, 8, 4, 5, 3, 4, 3, 6, 2, 6, 5, 4, 5, 2, 4, 5
dd 2, 8, 4, 5, 4, 5, 5, 6, 5, 5, 5, 5, 2, 2,12, 5
dd 3, 8, 4, 5, 3, 4, 3, 6, 2, 6, 3, 4, 5, 2, 4, 4
dd 2, 8, 4, 5, 4, 5, 5, 6, 5, 5, 5, 5, 2, 2, 3, 4
dd 3, 8, 4, 5, 4, 5, 4, 7, 2, 5, 6, 4, 5, 2, 4, 9
dd 2, 8, 4, 5, 5, 6, 6, 7, 4, 5, 4, 5, 2, 2, 6, 3
dd 2, 8, 4, 5, 3, 4, 3, 6, 2, 4, 5, 3, 4, 3, 4, 3
dd 2, 8, 4, 5, 4, 5, 5, 6, 3, 4, 5, 4, 2, 2, 4, 3


dd 0, 0, 0, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
dd 0, 0, 0, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
dd 0, 0, 0, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 0
dd 4, 0, 0, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
dd 0, 0, 0, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
dd 4, 0, 0, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
dd 0, 0, 0, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 0
dd 4, 0, 0, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
dd 0, 0, 0, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
dd 4, 0, 0, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
dd 0, 0, 0, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
dd 4, 0, 0, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
dd 0, 0, 0, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
dd 4, 0, 0, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 0
dd 0, 0, 0, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
dd 4, 0, 0, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 0

section .code
%if 0	;some 14k smaller
ALIGN16
NEWSYM _writebyte
  cmp ebx,0ffh+spcRam
  ja .extramem
  cmp ebx,0f0h+spcRam
  jb .normalmem
  sub ebx,spcRam
  jmp dword near [spcWptr+ebx*4-0f0h*4]
.extramem
  cmp ebx,0ffc0h+spcRam
  jb .normalmem
  test byte[spcRam+0F1h],80h
  mov [spcextraram+ebx-0FFC0h - spcRam],al  
  jnz .finished
  add ebx,spcRam
.normalmem
  mov [ebx],al
.finished
	ret

ALIGN16
NEWSYM _readbyte
  cmp ebx,0f0h+spcRam
  jb .rnormalmem2
  cmp ebx,0ffh+spcRam
  ja .rnormalmem
  sub ebx,spcRam
  jmp dword near [spcRptr+ebx*4-0f0h*4]
.rnormalmem
;  cmp ebx,0ffc0h+spcRam
;  jb .rnormalmem2
;  test byte [DSPMem+6Ch],10h
;  jz .rnormalmem2
;  mov al,[spcextraram+ebx-0FFC0h-spcRam]
;  jmp .rfinished
.rnormalmem2
   mov al,[ebx]
.rfinished
	ret

NEWSYM _readbyte2
  cmp ebx,0f0h+spcRam
  jb .rnormalmem2
  cmp ebx,0ffh+spcRam
  ja .rnormalmem
  sub ebx,spcRam
  push dword .rfinished
  jmp dword near [spcRptr+ebx*4-0f0h*4]
;  call dword near [spcRptr+ebx*4-0f0h*4]
;  jmp .rfinished
.rnormalmem
;  cmp ebx,0ffc0h+spcRam
;  jb .rnormalmem2
;  test byte [DSPMem+6Ch],10h
;  jz .rnormalmem2
;  mov al,[spcextraram+ebx-0FFC0h-spcRam]
;  jmp .rfinished
.rnormalmem2
   mov al,[ebx]
   jmp .finished
.rfinished
  add ebx,spcRam
.finished
	ret

%macro WriteByte 0
	call _writebyte
%endmacro

%macro ReadByte 0
	call _readbyte
%endmacro

%macro ReadByte2 0
	call _readbyte2
%endmacro

%else
%macro WriteByte 0
  cmp ebx,0ffh+spcRam
  ja %%extramem
  cmp ebx,0f0h+spcRam
  jb %%normalmem
  sub ebx,spcRam
  push dword %%finished
  jmp dword near [spcWptr+ebx*4-0f0h*4]
  ;call dword near [spcWptr+ebx*4-0f0h*4]
  ;jmp .finished
%%extramem
  cmp ebx,0ffc0h+spcRam
  jb %%normalmem
  test byte[spcRam+0F1h],80h
  mov [spcextraram+ebx-0FFC0h - spcRam],al  
  jnz %%finished
  ;add ebx,spcRam
;  push ecx
;  mov cl,[DSPMem+06Ch]
;  test cl,20h
;  pop ecx
;  jz .finished
%%normalmem
  mov [ebx],al
%%finished
%endmacro

%macro ReadByte 0
  cmp ebx,0f0h+spcRam
  jb %%rnormalmem2
  cmp ebx,0ffh+spcRam
  ja %%rnormalmem
  sub ebx,spcRam
  push dword %%rfinished
  jmp dword near [spcRptr+ebx*4-0f0h*4]
  ;call dword near [spcRptr+ebx*4-0f0h*4]
  ;jmp .rfinished
%%rnormalmem
;  cmp ebx,0ffc0h+spcRam
;  jb .rnormalmem2
;  test byte [DSPMem+6Ch],10h
;  jz .rnormalmem2
;  mov al,[spcextraram+ebx-0FFC0h-spcRam]
;  jmp .rfinished
%%rnormalmem2
   mov al,[ebx]
%%rfinished
%endmacro

%macro ReadByte2 0
  cmp ebx,0f0h+spcRam
  jb %%rnormalmem2
  cmp ebx,0ffh+spcRam
  ja %%rnormalmem
  sub ebx,spcRam
  push dword %%rfinished
  jmp dword near [spcRptr+ebx*4-0f0h*4]
;  call dword near [spcRptr+ebx*4-0f0h*4]
;  jmp %%rfinished
%%rnormalmem
;  cmp ebx,0ffc0h+spcRam
;  jb .rnormalmem2
;  test byte [DSPMem+6Ch],10h
;  jz .rnormalmem2
;  mov al,[spcextraram+ebx-0FFC0h-spcRam]
;  jmp .rfinished
%%rnormalmem2
   mov al,[ebx]
   jmp %%finished
%%rfinished
  add ebx,spcRam
%%finished
%endmacro

%endif

; SPC Write Registers
; DO NOT MODIFY DX OR ECX!
ALIGN4
NEWSYM SPCRegF0
      mov [spcRam+0F0h],al
      ret
ALIGN4
NEWSYM SPCRegF1
;      cmp byte[disablespcclr],1
;      je .No23Clear
      test al,10h
      jz .No01Clear
      mov byte [spcRam+0F4h],0
      mov byte [spcRam+0F5h],0
.No01Clear
      test al,20h
      jz .No23Clear
      mov byte [spcRam+0F6h],0
      mov byte [spcRam+0F7h],0
.No23Clear
;      cmp byte[SPCSkipXtraROM],1
;      je near .AfterNoROM
      test al,80h
      jz .NoROM
      push eax
      push ebx
      xor eax,eax
ALIGN4
.loopa
      mov bl,[SPCROM+eax]
      mov [spcRam+0FFC0h+eax],bl
      inc eax
      cmp eax,040h
      jne .loopa
      pop ebx
      pop eax
      jmp .AfterNoROM
.NoROM
      push eax
      push ebx
      xor eax,eax
ALIGN4
.loopb
      mov bl,[spcextraram+eax]
      mov [spcRam+0FFC0h+eax],bl
      inc eax
      cmp eax,040h
      jne .loopb
      pop ebx
      pop eax
.AfterNoROM
      mov [spcRam+0F1h],al
      and al,0Fh
      mov [timeron],al
      ret
ALIGN4
NEWSYM SPCRegF2
      mov [spcRam+0F2h],al
      push eax
      push ebx
      xor eax,eax
      mov al,[spcRam+0F2h]
      mov bl,[DSPMem+eax]
      mov [spcRam+0F3h],bl
      pop ebx
      pop eax
      ret
ALIGN4
NEWSYM SPCRegF3
      push ebx
      xor ebx,ebx
      mov bl,[spcRam+0F2h]
      and bl,07fh
      call dword near [dspWptr+ebx*4]
      pop ebx
      mov [spcRam+ebx],al
      ret
ALIGN4
NEWSYM SPCRegF4
;      mov [reg1read],al
;      inc dword[spc700read]
      ret
ALIGN4
NEWSYM SPCRegF5
;      mov [reg2read],al
;      inc dword[spc700read]
      ret
ALIGN4
NEWSYM SPCRegF6
;      mov [reg3read],al
;      inc dword[spc700read]
      ret
ALIGN4
NEWSYM SPCRegF7
;      mov [reg4read],al
;      inc dword[spc700read]
      ret
ALIGN4
NEWSYM SPCRegF8
      mov [spcRam+ebx],al
      ret
ALIGN4
NEWSYM SPCRegF9
      mov [spcRam+ebx],al
      ret

%macro timerfoo 1
      mov [timincr0+%1],al
      test byte[timinl0+%1],0FFh
      jne .nowrite
      mov [timinl0+%1],al
.nowrite
      mov [spcRam+ebx],al
      ret
%endmacro

ALIGN4
NEWSYM SPCRegFA
	 timerfoo 0

ALIGN4
NEWSYM SPCRegFB
	timerfoo 1

ALIGN4
NEWSYM SPCRegFC
	timerfoo 2

ALIGN4
NEWSYM SPCRegFD
      ret
ALIGN4
NEWSYM SPCRegFE
      ret
ALIGN4
NEWSYM SPCRegFF
      ret

; SPC Read Registers
; DO NOT MODIFY ANY REG!
; return data true al

ALIGN16
NEWSYM RSPCRegXX
	mov al,[spcRam+ebx]
	ret

%macro skipmacro 1
ALIGN4
.spcnextskip
  	  test byte[timeron],1<<%1
	  je .ret
	  cmp byte[timincr0+%1],0
	  je .ret
	  ;cmp byte[SpeedHack],0
	  ;je .ret
      inc byte[spcnumread+%1]
	  cmp byte[spcnumread+%1],8h
      je near haltspc
	  .ret
      ret
%endmacro

ALIGN16
NEWSYM haltspc
	  mov ebx,[spcnumread]
	  xor esi,esi	  
	  mov [halted],ebx
      mov dword[spcnumread],0
      ret


ALIGN4
NEWSYM RSPCRegFD
      mov al,[spcRam+0fdh]
      and al,0Fh
      cmp byte[spcRam+0fdh],0
      je .spcnextskip
      mov byte [spcRam+0fdh],0
      mov byte [spcnumread],0
      ret
	  skipmacro 0

ALIGN4
NEWSYM RSPCRegFE
      mov al,[spcRam+0feh]
      and al,0Fh
      cmp byte[spcRam+0feh],0
      je .spcnextskip
      mov byte [spcRam+0feh],0
      mov byte [spcnumread+1],0
      ret
	  skipmacro 1

ALIGN4
NEWSYM RSPCRegFF
      mov al,[spcRam+0ffh]
      and al,0Fh
      cmp byte[spcRam+0ffh],0
      je .spcnextskip
      mov byte [spcRam+0ffh],0
      mov byte [spcnumread+2],0
      ret
	  skipmacro 2

ALIGN4
NEWSYM RSPCRegFD_nohack
      mov al,[spcRam+0fdh]
      mov byte [spcRam+0fdh],0
      and al,0Fh
      ret

ALIGN4
NEWSYM RSPCRegFE_nohack
      mov al,[spcRam+0feh]
      mov byte [spcRam+0feh],0
      and al,0Fh
      ret

ALIGN4
NEWSYM RSPCRegFF_nohack
      mov al,[spcRam+0ffh]
      mov byte [spcRam+0ffh],0
      and al,0Fh
      ret

EXTSYM op_ret

%if 0	;enable for -10k dll size and -10% CPU core speed
ALIGN16
NEWSYM _ret_
	sub esi,[SPCCycleTable+edi*4]
	mov ebx,0
    jle near op_ret
    mov bl,[ebp]
    inc ebp
	mov edi, ebx
    jmp dword near [opcjmptab+ebx*4]

%macro _ret 0
	jmp _ret_
%endmacro

%else

%macro _ret 0
	sub esi,[SPCCycleTable+edi*4]
	mov ebx,0
    jle near op_ret
    mov bl,[ebp]
    inc ebp
	mov edi, ebx
    jmp dword near [opcjmptab+ebx*4]
%endmacro

%endif

%include "cpu/spcdef.inc"


;spcNF    db 0     ; The Negative Flag  128 or 127 80h
;spcOF    db 0     ; The Overflow Flag   64 or 191 40h
;spcDPF   db 0     ; Direct Page Flag    32 or 223 20h
;spcUF    db 0     ; The Unused Flag ?   16 or 239 10h
;spcHCF   db 0     ; The Half Carry Flag  8 or 247 08h
;spcIF    db 0     ; The interrupt flag   4 or 251 04h
;spcZF    db 0     ; The Zero Flag        2 or 253 02h
;spcCF    db 0     ; The Carry Flag       1 or 254 01h
;      test byte[spcP],08h
;      jz .nohcarry
;      or ah,00010000b
;.nohcarry

%macro SPCSetFlagnvhzcnoret 0
  lahf
  js .setsignflag
  jz .setzeroflag
  mov byte [spcNZ],1
  jo .setoverflowflag
  and byte [spcP],0BFh
  jmp .skipflags 
.setsignflag
  mov byte [spcNZ],80h
  jo .setoverflowflag
  and byte [spcP],0BFh
  jmp .skipflags
.setzeroflag
  mov byte [spcNZ],0
  jo .setoverflowflag
  and byte [spcP],0BFh
  jmp .skipflags
.setoverflowflag
  or byte [spcP],40h
.skipflags
  and byte [spcP],0F6h
  test ah,01h
  jz .noCarry
  or byte [spcP],1
.noCarry
  test ah,10h
  jz .nohf
  or byte [spcP],8
.nohf
%endmacro

%macro SPCSetFlagnvhzc 0
	SPCSetFlagnvhzcnoret
	_ret
%endmacro


;************************************************
; Misc Opcodes
;************************************************

ALIGN4
NEWSYM Op00       ; NOP
      _ret

ALIGN4
NEWSYM OpEF       ; SLEEP        standby SLEEP mode      .........
      dec ebp
      _ret

ALIGN4
NEWSYM OpFF       ; STOP         standby STOP mode       .........
;      inc dword[spc700read]
      dec ebp
      _ret

ALIGN4
NEWSYM Op9F       ; XCN A     A(7-4) <-> A(3-0)     N......Z.
      ror dl,4
      mov [spcNZ],dl
      _ret

;************************************************
; Branch Stuff
;************************************************

ALIGN4
NEWSYM Op10       ; BPL Branch on N=0
      test byte [spcNZ],128
      jz .branch
      spcbrancher

ALIGN4
NEWSYM Op30       ; BMI Branch on N=1
      test byte [spcNZ],128
      jnz .branch
      spcbrancher

ALIGN4
NEWSYM Op50       ; BVC Branch on V=0
      test byte [spcP],64
      jz .branch
      spcbrancher

ALIGN4
NEWSYM Op70       ; BVS Branch on V=1
      test byte [spcP],64
      jnz .branch
      spcbrancher

ALIGN4
NEWSYM Op90       ; BCC Branc on c=0
      test byte [spcP],1
      jz .branch
      spcbrancher

ALIGN4
NEWSYM OpB0       ; BCS Branch on C=1
      test byte [spcP],1
      jnz .branch
      spcbrancher

ALIGN4
NEWSYM OpD0       ; BNE branch on Z=0
      test byte [spcNZ],255
      jnz .branch
      spcbrancher

ALIGN4
NEWSYM OpF0       ; BEQ Branch on Z=1
      test byte [spcNZ],0FFh
      jz .branch
      spcbrancher

ALIGN4
NEWSYM Op2F       ; BRA rel      branch always                  ...
      movsx ebx,byte [ebp]
      inc ebp
      add ebp,ebx
      _ret

;************************************************
; Clear/Set Flag bits
;************************************************
;  CLRP               20    1     2   clear direct page flag    ..0..... 

ALIGN4
NEWSYM Op20       ; CLRP Clear direct page flag
      and byte [spcP],11011111b
      mov dword [spcRamDP],spcRam
      _ret
;  SETP               40    1     2   set direct page flag      ..1..0..

ALIGN4
NEWSYM Op40       ; SETP Set Direct Page Flag  (Also clear interupt flag?)
      or byte [spcP],00100000b
      mov dword [spcRamDP],spcRam+100h
	  and byte [spcP],11111011b
      ;add dword [spcRamDP],100h
      _ret
;  CLRC               60    1     2   clear carry flag          .......0 

ALIGN4
NEWSYM Op60       ; CLRC Clear carry flag
      and byte [spcP],11111110b
      _ret
;  SETC               80    1     2   set carry flag            .......1 

ALIGN4
NEWSYM Op80       ; SETC Set carry flag
      or byte [spcP],00000001b
      _ret
;  EI                 A0    1     3  set interrup enable flag   .....1.. 

ALIGN4
NEWSYM OpA0       ; EI set interrupt flag
      or byte [spcP],00000100b
      _ret
;  DI                 C0    1     3  clear interrup enable flag .....0..

ALIGN4
NEWSYM OpC0       ; DI clear interrupt flag
      and byte [spcP],11111011b
      _ret
;  CLRV               E0    1     2   clear V and H             .0..0... 

ALIGN4
NEWSYM OpE0       ; CLRV clear V and H
      and byte [spcP],10110111b
      _ret
;  NOTC               ED    1     3   complement carry flag     .......C 

ALIGN4
NEWSYM OpED       ; NOTC         complement carry flag     .......C 
      xor byte [spcP],00000001b
      _ret

;************************************************
; TCALL instructions (Verified)
;************************************************

ALIGN4
NEWSYM Op01       ; TCALL 0
      spctcall 30

ALIGN4
NEWSYM Op11       ; TCALL 1
      spctcall 28

ALIGN4
NEWSYM Op21       ; TCALL 2
      spctcall 26

ALIGN4
NEWSYM Op31       ; TCALL 3
      spctcall 24

ALIGN4
NEWSYM Op41       ; TCALL 4
      spctcall 22

ALIGN4
NEWSYM Op51       ; TCALL 5
      spctcall 20

ALIGN4
NEWSYM Op61       ; TCALL 6
      spctcall 18

ALIGN4
NEWSYM Op71       ; TCALL 7
      spctcall 16

ALIGN4
NEWSYM Op81       ; TCALL 8
      spctcall 14

ALIGN4
NEWSYM Op91       ; TCALL 9
      spctcall 12

ALIGN4
NEWSYM OpA1       ; TCALL A
      spctcall 10

ALIGN4
NEWSYM OpB1       ; TCALL B
      spctcall 08

ALIGN4
NEWSYM OpC1       ; TCALL C
      spctcall 06

ALIGN4
NEWSYM OpD1       ; TCALL D
      spctcall 04

ALIGN4
NEWSYM OpE1       ; TCALL E
      spctcall 02

ALIGN4
NEWSYM OpF1       ; TCALL F
      spctcall 00

;************************************************
; SET1 instructions (Verified)
;************************************************

ALIGN4
NEWSYM Op02       ; SET1 direct page bit 0
      set1 1 

ALIGN4
NEWSYM Op22       ; SET1 direct page bit 1
      set1 2

ALIGN4
NEWSYM Op42       ; SET1 direct page bit 2
      set1 4

ALIGN4
NEWSYM Op62       ; SET1 direct page bit 3
      set1 8

ALIGN4
NEWSYM Op82       ; SET1 direct page bit 4
      set1 16

ALIGN4
NEWSYM OpA2       ; SET1 direct page bit 5
      set1 32

ALIGN4
NEWSYM OpC2       ; SET1 direct page bit 6
      set1 64

ALIGN4
NEWSYM OpE2       ; SET1 direct page bit 7
      set1 128

;************************************************
; CLR1 instructions (Verified)
;************************************************

ALIGN4
NEWSYM Op12       ; CLR1 direct page bit 0
      clr1 255-1

ALIGN4
NEWSYM Op32       ; CLR1 direct page bit 1
      clr1 255-2

ALIGN4
NEWSYM Op52       ; CLR1 direct page bit 2
      clr1 255-4

ALIGN4
NEWSYM Op72       ; CLR1 direct page bit 3
      clr1 255-8

ALIGN4
NEWSYM Op92       ; CLR1 direct page bit 4
      clr1 255-16

ALIGN4
NEWSYM OpB2       ; CLR1 direct page bit 5
      clr1 255-32

ALIGN4
NEWSYM OpD2       ; CLR1 direct page bit 6
      clr1 255-64

ALIGN4
NEWSYM OpF2       ; CLR1 direct page bit 7
      clr1 255-128

;************************************************
; BBS instructions (Verified)
;************************************************

ALIGN4
NEWSYM Op03       ; BBS direct page bit 0
      bbs 1

ALIGN4
NEWSYM Op23       ; BBS direct page bit 1
      bbs 2

ALIGN4
NEWSYM Op43       ; BBS direct page bit 2
      bbs 4

ALIGN4
NEWSYM Op63       ; BBS direct page bit 3
      bbs 8

ALIGN4
NEWSYM Op83       ; BBS direct page bit 4
      bbs 16

ALIGN4
NEWSYM OpA3       ; BBS direct page bit 5
      bbs 32

ALIGN4
NEWSYM OpC3       ; BBS direct page bit 6
      bbs 64

ALIGN4
NEWSYM OpE3       ; BBS direct page bit 7
      bbs 128

;************************************************
; BBC instructions (Verified)
;************************************************

ALIGN4
NEWSYM Op13       ; BBC direct page bit 0
      bbc 1

ALIGN4
NEWSYM Op33       ; BBC direct page bit 1
      bbc 2

ALIGN4
NEWSYM Op53       ; BBC direct page bit 2
      bbc 4

ALIGN4
NEWSYM Op73       ; BBC direct page bit 3
      bbc 8

ALIGN4
NEWSYM Op93       ; BBC direct page bit 4
      bbc 16

ALIGN4
NEWSYM OpB3       ; BBC direct page bit 5
      bbc 32

ALIGN4
NEWSYM OpD3       ; BBC direct page bit 6
      bbc 64

ALIGN4
NEWSYM OpF3       ; BBC direct page bit 7
      bbc 128

;************************************************
; OR A,instructions
;************************************************

ALIGN4
NEWSYM Op04       ; OR A,dp   A <- A OR (dp)    N.....Z.
      SPCaddr_DP
      SPC_OR_A

ALIGN4
NEWSYM Op14       ; OR A,dp+X    A <- A OR (dp+X)     N.....Z.
      SPCaddr_DP_X
      SPC_OR_A

ALIGN4
NEWSYM Op05       ; OR A,labs   A <- A OR (abs)       N.....Z.
      SPCaddr_LABS
      SPC_OR_A

ALIGN4
NEWSYM Op15       ; OR A,labs+x  A <- A OR (abs+X)    N.....Z.
      SPCaddr_LABS_X
      SPC_OR_A

ALIGN4
NEWSYM Op06       ; OR A,(X)     A <- A OR (X)        N.....Z.
      SPCaddr__X_
      SPC_OR_A

ALIGN4
NEWSYM Op16       ; OR A,labs+Y  A <- A OR (abs+Y)    N......Z.
      SPCaddr_LABS_Y
      SPC_OR_A

ALIGN4
NEWSYM Op07       ; OR A,(dp+X)  A <- A OR ((dp+X+1)(dp+X))  N......Z.
      SPCaddr_bDP_Xb
      SPC_OR_A

ALIGN4
NEWSYM Op17       ; OR A,(dp)+Y  A <- A OR ((dp+1)(dp)+Y)   N......Z.
      SPCaddr_bDPb_Y
      SPC_OR_A

ALIGN4
NEWSYM Op08       ; OR A,#inm    A <- A OR inm            N......Z.
      mov al,[ebp]
      inc ebp
      SPC_OR_A

;************************************************
; AND A, instructions
;************************************************

ALIGN4
NEWSYM Op24       ; AND A,dp     A <- A AND (dp)      N.....Z.
      SPCaddr_DP
      SPC_AND_A

ALIGN4
NEWSYM Op34       ; AND A,dp+x   A <- A AND (dp+X)    N.....Z.
      SPCaddr_DP_X
      SPC_AND_A

ALIGN4
NEWSYM Op25       ; AND A,labs   A <- A AND (abs)     N.....Z.
      SPCaddr_LABS
      SPC_AND_A

ALIGN4
NEWSYM Op35       ; AND A,labs+X A <- A AND (abs+X)   N.....Z.
      SPCaddr_LABS_X
      SPC_AND_A

ALIGN4
NEWSYM Op26       ; AND A,(X)    A <- A AND (X)       N......Z.
      SPCaddr__X_
      SPC_AND_A

ALIGN4
NEWSYM Op36       ; AND A,labs+Y A <- A AND (abs+Y)   N......Z.
      SPCaddr_LABS_Y
      SPC_AND_A

ALIGN4
NEWSYM Op27       ; AND A,(dp+X) A <- A AND ((dp+X+1)(dp+X)) N......Z.
      SPCaddr_bDP_Xb
      SPC_AND_A

ALIGN4
NEWSYM Op37       ; AND A,(dp)+Y A <- A AND ((dp+1)(dp)+Y)  N......Z.
      SPCaddr_bDPb_Y
      SPC_AND_A

ALIGN4
NEWSYM Op28       ; AND A,#inm   A <- A AND inm           N......Z.
      mov al,[ebp]
      inc ebp
      SPC_AND_A

;************************************************
; EOR A, instructions
;************************************************

ALIGN4
NEWSYM Op44       ; EOR A,dp     A <- A EOR (dp)      N.....Z.
      SPCaddr_DP
      SPC_EOR_A

ALIGN4
NEWSYM Op54       ; EOR A,dp+x   A <- A EOR (dp+X)    N.....Z.
      SPCaddr_DP_X
      SPC_EOR_A

ALIGN4
NEWSYM Op45       ; EOR A,labs   A <- A EOR (abs)     N.....Z.
      SPCaddr_LABS
      SPC_EOR_A

ALIGN4
NEWSYM Op55       ; EOR A,labs+X A <- A EOR (abs+X)   N.....Z.
      SPCaddr_LABS_X
      SPC_EOR_A

ALIGN4
NEWSYM Op46       ; EOR A,(X)    A <- A EOR (X)       N......Z.
      SPCaddr__X_
      SPC_EOR_A

ALIGN4
NEWSYM Op56       ; EOR A,labs+Y A <- A EOR (abs+Y)   N......Z.
      SPCaddr_LABS_Y
      SPC_EOR_A

ALIGN4
NEWSYM Op47       ; EOR A,(dp+X) A <- A EOR ((dp+X+1)(dp+X)) N......Z.
      SPCaddr_bDP_Xb
      SPC_EOR_A

ALIGN4
NEWSYM Op57       ; EOR A,(dp)+Y A <- A EOR ((dp+1)(dp)+Y)  N......Z.
      SPCaddr_bDPb_Y
      SPC_EOR_A

ALIGN4
NEWSYM Op48       ; EOR A,#inm   A <- A EOR inm           N......Z.
      mov al,[ebp]
      inc ebp
      SPC_EOR_A

;************************************************
; CMP A, instructions
;************************************************

ALIGN4
NEWSYM Op64       ; CMP A,dp     A-(dp)               N.....ZC
      SPCaddr_DP
      SPC_CMP_A

ALIGN4
NEWSYM Op74       ; CMP A,dp+x   A-(dp+X)             N.....ZC
      SPCaddr_DP_X
      SPC_CMP_A

ALIGN4
NEWSYM Op65       ; CMP A,labs   A-(abs)              N.....ZC
      SPCaddr_LABS
      SPC_CMP_A

ALIGN4
NEWSYM Op75       ; CMP A,labs+X A-(abs+X)            N.....ZC
      SPCaddr_LABS_X
      SPC_CMP_A

ALIGN4
NEWSYM Op66       ; CMP A,(X)    A-(X)                N......ZC
      SPCaddr__X_
      SPC_CMP_A

ALIGN4
NEWSYM Op76       ; CMP A,labs+Y A-(abs+Y)            N......ZC
      SPCaddr_LABS_Y
      SPC_CMP_A

ALIGN4
NEWSYM Op67       ; CMP A,(dp+X) A-((dp+X+1)(dp+X))      N......ZC
      SPCaddr_bDP_Xb
      SPC_CMP_A

ALIGN4
NEWSYM Op77       ; CMP A,(dp)+Y A-((dp+1)(dp)+Y)        N......ZC
      SPCaddr_bDPb_Y
      SPC_CMP_A

ALIGN4
NEWSYM Op68       ; CMP A,#inm   A-inm                   N......ZC
      mov al,[ebp]
      inc ebp
      SPC_CMP_A

;************************************************
; ADC A, instructions
;************************************************

ALIGN4
NEWSYM Op84       ; ADC A,dp     A <- A+(dp)+C        NV..H.ZC
      SPCaddr_DP
      SPC_ADC_A

ALIGN4
NEWSYM Op94       ; ADC A,dp+x   A <- A+(dp+X)+C      NV..H.ZC
      SPCaddr_DP_X
      SPC_ADC_A

ALIGN4
NEWSYM Op85       ; ADC A,labs   A <- A+(abs)+C       NV..H.ZC
      SPCaddr_LABS
      SPC_ADC_A

ALIGN4
NEWSYM Op95       ; ADC A,labs+X A <- A+(abs+X)+C     NV..H.ZC
      SPCaddr_LABS_X
      SPC_ADC_A

ALIGN4
NEWSYM Op86       ; ADC A,(X)    A <- A+(X)+C         NV..H..ZC
      SPCaddr__X_
      SPC_ADC_A

ALIGN4
NEWSYM Op96       ; ADC A,labs+Y A <- A+(abs+Y)+C     NV..H..ZC
      SPCaddr_LABS_Y
      SPC_ADC_A

ALIGN4
NEWSYM Op87       ; ADC A,(dp+X) A <- A+((dp+X+1)(dp+X)) NV..H..ZC
      SPCaddr_bDP_Xb
      SPC_ADC_A

ALIGN4
NEWSYM Op97       ; ADC A,(dp)+Y A <- A+((dp+1)(dp)+Y)   NV..H..ZC
      SPCaddr_bDPb_Y
      SPC_ADC_A

ALIGN4
NEWSYM Op88       ; ADC A,#inm   A <- A+inm+C            NV..H..ZC
      mov al,[ebp]
      inc ebp
      SPC_ADC_A

;************************************************
; SBC A, instructions
;************************************************

ALIGN4
NEWSYM OpA4       ; SBC A,dp     A <- A-(dp)-!C       NV..H.ZC
      SPCaddr_DP
      SPC_SBC_A

ALIGN4
NEWSYM OpB4       ; SBC A,dp+x   A <- A-(dp+X)-!C     NV..H.ZC
      SPCaddr_DP_X
      SPC_SBC_A

ALIGN4
NEWSYM OpA5       ; SBC A,labs   A <- A-(abs)-!C      NV..H.ZC
      SPCaddr_LABS
      SPC_SBC_A

ALIGN4
NEWSYM OpB5       ; SBC A,labs+x A <- A-(abs+X)-!C    NV..H.ZC
      SPCaddr_LABS_X
      SPC_SBC_A

ALIGN4
NEWSYM OpA6       ; SBC A,(X)    A <- A-(X)-!C        NV..H..ZC
      SPCaddr__X_
      SPC_SBC_A

ALIGN4
NEWSYM OpB6       ; SBC A,labs+Y A <- A-(abs+Y)-!C    NV..H..ZC
      SPCaddr_LABS_Y
      SPC_SBC_A

ALIGN4
NEWSYM OpA7       ; SBC A,(dp+X) A <- A-((dp+X+1)(dp+X))-!C NV..H..ZC
      SPCaddr_bDP_Xb
      SPC_SBC_A

ALIGN4
NEWSYM OpB7       ; SBC A,(dp)+Y A <- A-((dp+1)(dp)+Y)-!C   NV..H..ZC
      SPCaddr_bDPb_Y
      SPC_SBC_A

ALIGN4
NEWSYM OpA8       ; SBC A,#inm   A <- A-inm-!C           NV..H..ZC
      mov al,[ebp]
      inc ebp
      SPC_SBC_A

;************************************************
; MOV A, instructions
;************************************************

ALIGN4
NEWSYM OpE4       ; MOV A,dp     A <- (dp)            N......Z
      SPCaddr_DP
      SPC_MOV_A

ALIGN4
NEWSYM OpF4       ; MOV A,dp+x   A <- (dp+X)          N......Z
      SPCaddr_DP_X
      SPC_MOV_A

ALIGN4
NEWSYM OpE5       ; MOV A,labs   A <- (abs)           N......Z
      SPCaddr_LABS
      SPC_MOV_A

ALIGN4
NEWSYM OpF5       ; MOV A,labs+X A <- (abs+X)         N......Z
      SPCaddr_LABS_X
      SPC_MOV_A

ALIGN4
NEWSYM OpE6       ; MOV A,(X)    A <- (X)             N......Z
      SPCaddr__X_
      SPC_MOV_A

ALIGN4
NEWSYM OpF6       ; MOV A,labs+Y A <- (abs+Y)         N......Z
      SPCaddr_LABS_Y
      SPC_MOV_A

ALIGN4
NEWSYM OpE7       ; MOV A,(dp+X) A <- ((dp+X+1)(dp+X))     N......Z
      SPCaddr_bDP_Xb
      SPC_MOV_A

ALIGN4
NEWSYM OpF7       ; MOV A,(dp)+Y A <- ((dp+1)(dp)+Y)       N......Z
      SPCaddr_bDPb_Y
      SPC_MOV_A

ALIGN4
NEWSYM OpE8       ;  MOV A,#inm  A <- inm                  N......Z
      mov al,[ebp]
      inc ebp
      SPC_MOV_A

;************************************************
; DP,#imm instructions
;************************************************

%macro spcgetdp_imm 0
      mov bl,[ebp+1]
      mov ah,[ebp]
      add ebx,[spcRamDP]
      ReadByte2
      add ebp,2
%endmacro

ALIGN4
NEWSYM OpB8       ; SBC dp,#inm  (dp) <- (dp)-inm-!C        NV..H..ZC
      spcgetdp_imm ; bl<-[ebp+1], ah<-[ebp], ebx+[spcRamDP],Readbyte,ebp+2
      mov cl,[spcP]
      xor cl,1
      shr cl,1
      sbb al,ah
      cmc
      SPCSetFlagnvhzcnoret
      WriteByte
      _ret

ALIGN4
NEWSYM Op98       ; ADC dp,#inm  (dp) <- (dp)+inm+C         NV..H..ZC
      spcgetdp_imm ; bl<-[ebp+1], ah<-[ebp], ebx+[spcRamDP],Readbyte,ebp+2
      mov cl,[spcP]
      shr cl,1
      adc al,ah
      SPCSetFlagnvhzcnoret
      WriteByte
      _ret

ALIGN4
NEWSYM Op78       ; CMP dp,#inm  (dp)-inm                N......ZC
      mov bl,[ebp+1]
      mov ah,[ebp]
      add ebx,[spcRamDP]
      ReadByte
      add ebp,2
      cmp al,ah
      cmc
      SPCSetFlagnzcnoret
      _ret

ALIGN4
NEWSYM Op58      ; EOR dp,#inm  (dp) <- (dp) EOR inm        N......Z.
      spcgetdp_imm ; bl<-[ebp+1], ah<-[ebp], ebx+[spcRamDP],Readbyte,ebp+2
      xor al,ah
      mov [spcNZ], al
      WriteByte
      _ret

ALIGN4
NEWSYM Op38       ; AND dp,#inm  (dp) <- (dp) AND inm        N......Z.
      spcgetdp_imm ; bl<-[ebp+1], ah<-[ebp], ebx+[spcRamDP],Readbyte,ebp+2
      and al,ah
      mov [spcNZ], al
      WriteByte
      _ret

ALIGN4
NEWSYM Op18       ; OR dp,#inm   (dp) <- (dp) OR inm         N......Z.
      spcgetdp_imm ; bl<-[ebp+1], ah<-[ebp], ebx+[spcRamDP],Readbyte,ebp+2
      or al,ah
      mov [spcNZ],al
      WriteByte
      _ret

;************************************************
; DP(D),DP(S) instructions
;************************************************
%macro spcaddrDPbDb_DPbSb 1
      xor ecx,ecx
      mov bl,[ebp+1]
      mov cl,[ebp]
      add ebx,[spcRamDP]
      add ebp,2
      add ecx,[spcRamDP]
      push ebx
      ReadByte
      mov ebx,ecx
      mov cl,al
%1
      ReadByte
      mov ah,al
      mov al,cl
      pop ebx
%endmacro

ALIGN4
NEWSYM Op09       ; OR dp(d),dp(s)  (dp(d))<-(dp(d)) OR (dp(s))  N......Z.
      spcaddrDPbDb_DPbSb Op09b:
      or al,ah
      mov [spcNZ], al
      WriteByte
      xor ecx,ecx
      _ret

ALIGN4
NEWSYM Op29       ; AND dp(d),dp(s) (dp(d))<-(dp(d)) AND (dp(s)) N......Z.
      spcaddrDPbDb_DPbSb Op29b:
      and al,ah
      mov [spcNZ], al
      WriteByte
      xor ecx,ecx
      _ret

ALIGN4
NEWSYM Op49       ; EOR dp(d),dp(s) (dp(d))<-(dp(d)) EOR (dp(s)) N......Z.
      spcaddrDPbDb_DPbSb Op49b:
      xor al,ah
      mov [spcNZ], al
      WriteByte
      xor ecx,ecx
      _ret

ALIGN4
NEWSYM Op69       ; CMP dp(d),dp(s) (dp(d))-(dp(s))         N......ZC
      spcaddrDPbDb_DPbSb Op69b:
      cmp al,ah
      cmc
      SPCSetFlagnzcnoret
      xor ecx,ecx
      _ret

ALIGN4
NEWSYM Op89       ; ADC dp(d),dp(s) (dp(d))<-(dp(d))+(dp(s))+C  NV..H..ZC
      spcaddrDPbDb_DPbSb Op89b
      mov cl,[spcP]
      shr cl,1
      adc al,ah
      SPCSetFlagnvhzcnoret
      WriteByte
      xor ecx,ecx
      _ret

ALIGN4
NEWSYM OpA9       ; SBC dp(d),dp(s) (dp(d))<-(dp(d))-(dp(s))-!C NV..H..ZC
      spcaddrDPbDb_DPbSb OpA9b
      mov cl,[spcP]
      xor cl,1
      shr cl,1
      sbb al,ah
      cmc
      SPCSetFlagnvhzcnoret
      WriteByte
      xor ecx,ecx
      _ret

ALIGN4
NEWSYM OpFA       ; MOV dp(d),dp(s) (dp(d)) <- (dp(s))        ........
      xor ecx,ecx
      mov bl,[ebp+1]
      mov cl,[ebp]
      add ebx,[spcRamDP]
      add ecx,[spcRamDP]
      add ebp,2
      push ebx
      mov ebx,ecx
      ReadByte
      pop ebx
      WriteByte
      xor ecx,ecx
      _ret

;************************************************
; (X),(Y) instructions
;************************************************
%macro spcaddrDPbXb_bYb 1
      mov bl,dh
      add ebx,[spcRamDP]
      ReadByte
      xor ebx,ebx
      mov ah,al
      mov bl,[spcX]
      add ebx,[spcRamDP]
%1
      ReadByte
%endmacro

ALIGN4
NEWSYM Op19       ; OR (X),(Y)   (X) <- (X) OR (Y)          N......Z.
      spcaddrDPbXb_bYb Op19b:
      or al, ah
      mov [spcNZ],al
      WriteByte
      _ret

ALIGN4
NEWSYM Op39       ; AND (X),(Y)  (X) <- (X) AND (Y)         N......Z.
      spcaddrDPbXb_bYb Op39b:
      and al, ah
      mov [spcNZ],al
      WriteByte
      _ret


ALIGN4
NEWSYM Op59       ; EOR (X),(Y)  (X) <- (X) EOR (Y)         N......Z.
      spcaddrDPbXb_bYb Op59b:
      xor al, ah
      mov [spcNZ],al
      WriteByte
      _ret
     
ALIGN4
NEWSYM Op79       ; CMP (X),(Y)  (X)-(Y)                 N......ZC
      spcaddrDPbXb_bYb Op79b:
      cmp al, ah
      cmc
      SPCSetFlagnzc

ALIGN4
NEWSYM Op99       ; ADC (X),(Y)  (X) <- (X)+(Y)+C          NV..H..ZC
      spcaddrDPbXb_bYb Op99b:
      mov cl,[spcP]
      shr cl,1
      adc al,ah
      SPCSetFlagnvhzcnoret
      WriteByte
      _ret

ALIGN4
NEWSYM OpB9       ; SBC (X),(Y)  (X) <- (X)-(Y)-!C         NV..H..ZC
      spcaddrDPbXb_bYb OpB9b:
      mov cl,[spcP]
      xor cl,1
      shr cl,1
      sbb al,ah
      cmc
      SPCSetFlagnvhzcnoret
      WriteByte
      _ret

;************************************************
; MOV ,A instructions (Verified)
;************************************************

ALIGN4
NEWSYM OpC4       ; MOV dp,A     A -> (dp)            ........
      mov bl,[ebp]
      mov al,dl
      add ebx,[spcRamDP]
      inc ebp
      WriteByte
      _ret

ALIGN4
NEWSYM OpD4       ; MOV dp+x,A   A -> (dp+X)          ........
      mov bl,[ebp]
      add bl,[spcX]
      mov al, dl
      add ebx,[spcRamDP]
      inc ebp
      WriteByte
      _ret

ALIGN4
NEWSYM OpC5       ; MOV labs,A   A -> (abs)           ........
      mov bx,[ebp]
      mov al, dl
      add ebp,2
      add ebx,spcRam
      WriteByte
      _ret

ALIGN4
NEWSYM OpD5       ; MOV labs+X,A A -> (abs+X)         ........
      mov bl,[spcX]
      add bx,[ebp]
      mov al, dl
      add ebp,2
      add ebx,spcRam
      WriteByte
      _ret

ALIGN4
NEWSYM OpC6       ; MOV (X),A    A -> (X)             ........
      mov bl,[spcX]
      add ebx,[spcRamDP]
      mov al, dl
      WriteByte
      _ret

ALIGN4
NEWSYM OpD6       ; MOV labs+Y,A A -> (abs+Y)         ........
      mov bl,dh
      mov al, dl
      add bx,[ebp]
      add ebp,2
      add ebx,spcRam
      WriteByte
      _ret

ALIGN4
NEWSYM OpC7       ; MOV (dp+X),A A -> ((dp+X+1)(dp+X))     ........
      mov bl,[ebp]
      add bl,[spcX]
      xor eax,eax
      add ebx,[spcRamDP]
      inc ebp
      mov ax, word [ebx]
      mov ebx,eax
      add ebx,spcRam
      mov al, dl
      WriteByte
      _ret

ALIGN4
NEWSYM OpD7       ; MOV (dp)+Y,A A -> ((dp+1)(dp)+Y)       ........
      mov bl,[ebp]
      xor eax,eax
      add ebx,[spcRamDP]
      inc ebp
      mov ax, word [ebx]
      ;add ax,[spcY] oy
	  add al,dh
	  adc ah,0
      mov ebx,eax
      add ebx,spcRam
      mov al, dl
      WriteByte
      _ret

;************************************************
; MOV instructions (Verified)
;************************************************

ALIGN4
NEWSYM OpD8       ; MOV dp,X     X -> (dp)                 ........
      mov bl,[ebp]
      mov al, byte [spcX]
      add ebx,[spcRamDP]
      inc ebp
      WriteByte
      _ret

ALIGN4
NEWSYM OpF8       ;  MOV X,dp    X <- (dp)                 N......Z
      mov bl,[ebp]
      inc ebp
      add ebx,[spcRamDP]
      ReadByte
      mov byte [spcX], al
      mov [spcNZ],al
      _ret

ALIGN4
NEWSYM OpC9       ; MOV labs,X   X -> (abs)                ........
      mov bx,[ebp]
      mov al, byte [spcX]
      add ebp,2
      add ebx,spcRam
      WriteByte
      _ret

ALIGN4
NEWSYM OpE9       ; MOV X,labs   X <- (abs)                N......Z
      mov bx,[ebp]
      add ebx,spcRam
      ReadByte
      add ebp,2
      mov byte [spcX], al
      mov [spcNZ],al
      _ret

ALIGN4
NEWSYM OpD9       ; MOV dp+Y,X   X -> (dp+Y)               ........
      mov bl,[ebp]
      mov al, byte [spcX]
      add bl,dh
      inc ebp
      add ebx,[spcRamDP]
      WriteByte
      _ret

ALIGN4
NEWSYM OpF9       ; MOV X,dp+Y   X <- (dp+Y)               N......Z
      mov bl,[ebp]
      add bl,dh
      inc ebp
      add ebx,[spcRamDP]
      ReadByte
      mov byte [spcX], al
      mov [spcNZ],al
      _ret

ALIGN4
NEWSYM OpCB       ; MOV dp,Y  Y -> (dp)                 ........
      mov bl,[ebp]
      mov al, dh
      add ebx,[spcRamDP]
      inc ebp
      WriteByte
      _ret

ALIGN4
NEWSYM OpEB       ; MOV Y,dp  Y <- (dp)                 N......Z
      mov bl,[ebp]
      add ebx,[spcRamDP]
      inc ebp
      ReadByte
      mov dh, al
      mov [spcNZ],al
      _ret

ALIGN4
NEWSYM OpDB       ; MOV dp+X,Y   X -> (dp+X)               ........
      mov bl,[ebp]
      add bl,[spcX]
      mov al, dh
      add ebx,[spcRamDP]
      inc ebp
      WriteByte
      _ret

ALIGN4
NEWSYM OpFB       ; MOV Y,dp+X   Y <- (dp+X)               N......Z
      mov bl,[ebp]
      add bl,[spcX]
      inc ebp
      add ebx,[spcRamDP]
      ReadByte
      mov dh, al
      mov [spcNZ],al
      _ret

ALIGN4
NEWSYM OpCC       ; MOV labs,Y   Y -> (abs)                ........
      mov bx,[ebp]
      mov al, dh
      add ebp,2
      add ebx,spcRam
      WriteByte
      _ret

ALIGN4
NEWSYM OpEC       ; MOV Y,labs   Y <- (abs)                N......Z
      mov bx,[ebp]
      add ebx,spcRam
      ReadByte
      add ebp,2
      mov dh,al
      mov [spcNZ],al
      _ret

ALIGN4
NEWSYM Op5D       ; MOV X,A      X <- A                   N......
      mov [spcX],dl
      mov [spcNZ],dl
      _ret

ALIGN4
NEWSYM Op7D       ; MOV A,X      A <- X                   N......Z
      mov al,[spcX]
      mov dl,al
      mov [spcNZ],al
      _ret

ALIGN4
NEWSYM Op8D       ; MOV Y,#inm   Y <- inm                  N......Z
      mov bl,[ebp]
      mov dh,bl
      inc ebp
      mov [spcNZ],bl
      _ret

ALIGN4
NEWSYM OpCD       ; MOV X,#inm   X <- inm                  N......Z
      mov bl,[ebp]
      mov [spcX],bl
      inc ebp
      mov [spcNZ],bl
      _ret

ALIGN4
NEWSYM Op8F       ; MOV dp,#inm  (dp) <- inm               ........
      mov bl,[ebp+1]
      mov al,[ebp]
      add ebx,[spcRamDP]
      add ebp,2
      WriteByte
      _ret

ALIGN4
NEWSYM Op9D       ; MOV X,SP     X <- SP                  N......Z
      mov al,[spcS]
      mov [spcX],al
      mov [spcNZ],al
      _ret

ALIGN4
NEWSYM OpBD       ; MOV SP,X     SP <- X                   ........
      mov al,[spcX]
      mov [spcS],al
      _ret

ALIGN4
NEWSYM OpDD       ; MOV A,Y      A <- Y                   N......Z
      mov dl,dh
      mov [spcNZ],dh
      _ret


ALIGN4
NEWSYM OpFD       ; MOV Y,A      Y <- A                   N......Z
      mov dh,dl
      mov [spcNZ],dl
      _ret

ALIGN4
NEWSYM OpAF       ; MOV (X)+,A   A -> (X) with auto inc    ........
      mov bl,[spcX]
      add ebx,[spcRamDP]
      mov al, dl
      inc byte [spcX]
      WriteByte
      _ret

ALIGN4
NEWSYM OpBF       ; MOV A,(X)+  A <- (X) with auto inc    N......Z
      mov bl,[spcX]
      add ebx,[spcRamDP]
      ReadByte
      inc byte [spcX]
      mov dl,al
      mov [spcNZ],al
      _ret
      

;************************************************
; CMP instructions (Verified)
;************************************************

ALIGN4
NEWSYM OpC8       ; CMP X,#inm   X-inm                   N......ZC
      mov bl,[ebp]
      inc ebp
      cmp [spcX],bl
      cmc
      SPCSetFlagnzc

ALIGN4
NEWSYM OpAD       ; CMP Y,#inm   Y-inm                   N......ZC
      mov bl,[ebp]
      inc ebp
      cmp dh,bl
      cmc
      SPCSetFlagnzc

ALIGN4
NEWSYM Op1E       ; CMP X,labs   X-(abs)                 N......ZC
      mov bx,[ebp]
      add ebp,2
      add ebx,spcRam
      ReadByte
      cmp byte [spcX], al
      cmc
      SPCSetFlagnzc

ALIGN4
NEWSYM Op3E       ; CMP X,dp     X-(dp)                  N......ZC
      mov bl,[ebp]
      add ebx,[spcRamDP]
      inc ebp
      ReadByte
      cmp byte [spcX], al
      cmc
      SPCSetFlagnzc

ALIGN4
NEWSYM Op5E       ; CMP Y,labs   Y-(abs)                 N......ZC
      mov bx,[ebp]
      add ebx,spcRam
      ReadByte
      add ebp,2
      cmp dh, al
      cmc
      SPCSetFlagnzc

ALIGN4
NEWSYM Op7E       ; CMP Y,dp     Y-(dp)                  N......ZC
      mov bl,[ebp]
      add ebx,[spcRamDP]
      inc ebp
      ReadByte
      cmp dh, al
      cmc
      SPCSetFlagnzc

;************************************************
; Word Instructions (Verified)
;************************************************

ALIGN4
NEWSYM Op1A       ; DECW dp   Decrement dp memory pair  N......Z.
      mov bl,[ebp]
      add ebx,[spcRamDP]
      inc ebp
      inc ebx
      ReadByte2
      mov ah,al
      dec ebx
NEWSYM Op1AB
      ReadByte2
      dec ax
      test ax,8000h
      jnz .YesNeg
      cmp ax,0000h
      je .YesZero
      mov byte [spcNZ],1
      jmp .SkipFlag
.YesNeg
      mov byte [spcNZ],80h
      jmp .SkipFlag
.YesZero
      mov byte [spcNZ],0
.SkipFlag
      push ebx
      WriteByte
      pop ebx
NEWSYM Op1Ab
      inc ebx
      mov al,ah
      WriteByte
      _ret

ALIGN4
NEWSYM Op3A       ; INCW dp   Increment dp memory pair  N......Z.
      mov bl,[ebp]
      add ebx,[spcRamDP]
      inc ebp
      inc ebx
      ReadByte2
      mov ah,al
      dec ebx
NEWSYM Op3AB
      ReadByte2
      inc ax
      test ax,8000h
      jnz .YesNeg
      cmp ax,0000h
      je .YesZero
      mov byte [spcNZ],1
      jmp .SkipFlag
.YesNeg
      mov byte [spcNZ],80h
      jmp .SkipFlag
.YesZero
      mov byte [spcNZ],0
.SkipFlag
      push ebx
      WriteByte
      pop ebx
NEWSYM Op3Ab
      inc ebx
      mov al,ah
      WriteByte
      _ret

; looks like there is the Carry flag checked in op5a..

ALIGN4
NEWSYM Op5A       ; CMPW YA,dp   YA - (dp+1)(dp)        N......ZC
      mov bl,[ebp]
      add ebx,[spcRamDP]
      inc ebp
      inc ebx
      ReadByte2
      mov ah,al
      dec ebx
NEWSYM Op5AB
      ReadByte
      cmp dx,ax
      cmc
      SPCSetFlagnzc

ALIGN4
NEWSYM Op7A       ; ADDW YA,dp   YA  <- YA + (dp+1)(dp)   NV..H..ZC
      mov bl,[ebp]
      add ebx,[spcRamDP]
      inc ebp
      inc ebx
      ReadByte2
      mov ah,al
      dec ebx
NEWSYM Op7AB
      ReadByte
      add dx,ax
      SPCSetFlagnvhzc

ALIGN4
NEWSYM Op9A       ; SUBW YA,dp   YA  <- YA - (dp+1)(dp)   NV..H..ZC
      mov bl,[ebp]
      add ebx,[spcRamDP]
      inc ebp
      inc ebx
      ReadByte2
      mov ah,al
      dec ebx
NEWSYM Op9AB
      ReadByte
      sub dx,ax
      cmc
      SPCSetFlagnvhzc

ALIGN4
NEWSYM OpBA       ; MOVW YA,dp   YA  - (dp+1)(dp)       N......Z.
      mov bl,[ebp]
      add ebx,[spcRamDP]
      inc ebp
      inc ebx
      ReadByte2
      mov ah,al
      dec ebx
NEWSYM OpBAb
      ReadByte
	  mov dx,ax
      test ax,8000h
      jnz .YesNeg
      cmp ax,0000h
      je .YesZero
      mov byte [spcNZ],1
      _ret
ALIGN4
.YesNeg
      mov byte [spcNZ],80h
      _ret
ALIGN4
.YesZero
      mov byte [spcNZ],0
      _ret

ALIGN4
NEWSYM OpDA       ; MOVW dp,YA   (dp+1)(dp) - YA         .........
      mov bl,[ebp]
      mov al,dl
      add ebx,[spcRamDP]
      inc ebp
      push ebx
      WriteByte
      pop ebx
      inc ebx
      mov al,dh
NEWSYM OpDAb
      WriteByte
      _ret

;************************************************
; mem.bit instructions (Verified)
;************************************************

%macro spcaddrmembit 0
      mov bx,[ebp]

      mov cl,bh
      add ebp,2
      shr cl,5
      and bx,1FFFh

;      mov cl,bl
;      add ebp,2
;      shr bx,3
;      and cl,00000111b

      add ebx,spcRam
      ReadByte
      shr al,cl
      and al,01h
%endmacro

ALIGN4
NEWSYM Op0A       ; OR1 C,mem.bit   C <- C OR  (mem.bit)      ........C
      spcaddrmembit
      or [spcP],al
      _ret

ALIGN4
NEWSYM Op2A       ; OR1 C,/mem.bit  C <- C OR  !(mem.bit)     ........C
      spcaddrmembit
      xor al,01h
      or [spcP],al
      _ret

ALIGN4
NEWSYM Op4A       ; AND1 C,mem.bit  C <- C AND (mem.bit)      ........C
      mov bx,[ebp]

      mov cl,bh
      add ebp,2
      shr cl,5
      and bx,1FFFh

;      mov cl,bl
;      add ebp,2
;      shr bx,3
;      and cl,00000111b

      add ebx,spcRam
      ReadByte
      shr al,cl
      or al,0FEh
      and [spcP],al
      _ret

ALIGN4
NEWSYM Op6A       ; AND1 C,/mem.bit C <- C AND !(mem.bit)     ........C
      mov bx,[ebp]

      mov cl,bh
      add ebp,2
      shr cl,5
      and bx,1FFFh

;      mov cl,bl
;      add ebp,2
;      shr bx,3
;      and cl,00000111b

      add ebx,spcRam
      ReadByte
      shr al,cl
      or al,0FEh
      xor al,01h
      and [spcP],al
      _ret

ALIGN4
NEWSYM Op8A       ; EOR1 C,mem.bit  C <- C EOR (mem.bit)      ........C
      spcaddrmembit
      xor [spcP],al
      _ret

ALIGN4
NEWSYM OpAA       ; MOV1 C,mem.bit  C <- (mem.bit)
      spcaddrmembit
      and byte[spcP],0FEh
      or [spcP],al
      _ret

ALIGN4
NEWSYM OpCA       ; MOV1 mem.bit,C  C -> (mem.bit)            .........
      mov bx,[ebp]
      mov al,[spcP]

      mov cl,bh
      mov ah,01h
      shr cl,5
      and bx,1FFFh

;      mov cl,bl
;      mov ah,01h
;      and cl,00000111b
;      shr bx,3

      shl ah,cl
      and al,01h
      add ebp,2
      shl al,cl
      add ebx,spcRam
      ; al = carry flag positioned in correct location, ah = 1 positioned
      mov cl,al
      xor ah,0FFh
      ReadByte2
      and al,ah
      or al,cl
      WriteByte
      _ret

ALIGN4
NEWSYM OpEA       ; NOT1 mem.bit    complement (mem.bit)      .........
      mov bx,[ebp]

      mov cl,bh
      mov ah,01h
      shr cl,5
      and bx,1FFFh

;      mov cl,bl
;      mov ah,01h
;      and cl,00000111b
;      shr bx,3

      shl ah,cl
      add ebp,2
      add ebx,spcRam
      ReadByte2
      xor al,ah
      WriteByte
      _ret

;************************************************
; Shift Instructions (Verified)
;************************************************

ALIGN4
NEWSYM Op0B       ; ASL dp    C << (dp)   <<0       N......ZC
      mov bl,[ebp]
      add ebx,[spcRamDP]
      inc ebp
      ReadByte2
      shl al,1
      SPCSetFlagnzcnoret
      WriteByte
      _ret

ALIGN4
NEWSYM Op4B       ; LSR dp    0 >> (dp)   <<C       N......ZC
      mov bl,[ebp]
      add ebx,[spcRamDP]
      inc ebp
      ReadByte2
      shr al,1
      SPCSetFlagnzcnoret
      WriteByte
      _ret

ALIGN4
NEWSYM Op1B       ; ASL dp+X  C << (dp+X) <<0       N......ZC
      mov bl,[ebp]
      add bl,[spcX]
      inc ebp
      add ebx,[spcRamDP]
      ReadByte2
      shl al,1
      SPCSetFlagnzcnoret
      WriteByte
      _ret

ALIGN4
NEWSYM Op5B       ; LSR dp+X  0 >> (dp+X) <<C       N......ZC
      mov bl,[ebp]
      add bl,[spcX]
      inc ebp
      add ebx,[spcRamDP]
      ReadByte2
      shr al,1
      SPCSetFlagnzcnoret
      WriteByte
      _ret

ALIGN4
NEWSYM Op0C       ; ASL labs  C << (abs)  <<0       N......ZC
      mov bx,[ebp]
      add ebx,spcRam
      add ebp,2
      ReadByte2
      shl al,1
      SPCSetFlagnzcnoret
      WriteByte
      _ret

ALIGN4
NEWSYM Op4C       ; LSR labs  0 >> (abs)  <<C       N......ZC
      mov bx,[ebp]
      add ebx,spcRam
      add ebp,2
      ReadByte2
      shr al,1
      SPCSetFlagnzcnoret
      WriteByte
      _ret

ALIGN4
NEWSYM Op1C       ; ASL A  C << A      <<0       N......ZC
      shl dl,1
      SPCSetFlagnzc

ALIGN4
NEWSYM Op5C       ; LSR A  0 >> A      <<C       N......ZC
      shr dl,1
      SPCSetFlagnzc

%macro spcROLstuff 0
      rcl al,1
      jc .setcarryflag
      and byte[spcP],0FEh
      mov [spcNZ],al
      jmp .skipflags
.setcarryflag
      or byte[spcP],01h
      mov [spcNZ],al
.skipflags
%endmacro

%macro spcRORstuff 0
      rcr al,1
      jc .setcarryflag
      and byte[spcP],0FEh
      mov [spcNZ],al
      jmp .skipflags
.setcarryflag
      or byte[spcP],01h
      mov [spcNZ],al
.skipflags
%endmacro

ALIGN4
NEWSYM Op2B       ; ROL dp    C << (dp)   <<C       N......ZC
      mov bl,[ebp]
      add ebx,[spcRamDP]
      inc ebp
      test byte [spcP],01h
      jnz near Op2Bb
      ReadByte2
      clc
      spcROLstuff
      WriteByte
      _ret
ALIGN4
NEWSYM Op2Bb
      ReadByte2
      stc
      spcROLstuff
      WriteByte
      _ret

ALIGN4
NEWSYM Op6B       ; ROR dp    C >> (dp)   <<C       N......ZC
      mov bl,[ebp]
      add ebx,[spcRamDP]
      inc ebp
      test byte [spcP],01h
      jnz near Op6Bb
      ReadByte2
      clc
      spcRORstuff
      WriteByte
      _ret
ALIGN4
NEWSYM Op6Bb
      ReadByte2
      stc
      spcRORstuff
      WriteByte
      _ret

ALIGN4
NEWSYM Op3B       ; ROL dp+X  C << (dp+X) <<C       N......ZC
      mov bl,[ebp]
      add bl,[spcX]
      add ebx,[spcRamDP]
      inc ebp
      test byte [spcP],01h
      jnz near Op3Bb
      ReadByte2
      clc
      spcROLstuff
      WriteByte
      _ret
ALIGN4
NEWSYM Op3Bb
      ReadByte2
      stc
      spcROLstuff
      WriteByte
      _ret

ALIGN4
NEWSYM Op7B       ; ROR dp+X  C >> (dp+X) <<C       N......ZC
      mov bl,[ebp]
      add bl,[spcX]
      add ebx,[spcRamDP]
      inc ebp
      test byte [spcP],01h
      jnz near Op7Bb
      ReadByte2
      clc
      spcRORstuff
      WriteByte
      _ret
ALIGN4
NEWSYM Op7Bb
      ReadByte2
      stc
      spcRORstuff
      WriteByte
      _ret

ALIGN4
NEWSYM Op2C       ; ROL labs  C << (abs)  <<C       N......ZC
      mov bx,[ebp]
      add ebx,spcRam
      add ebp,2
      test byte [spcP],01h
      jnz near Op2Cb
      ReadByte2
      clc
      spcROLstuff
      WriteByte
      _ret
ALIGN4
NEWSYM Op2Cb
      ReadByte2
      stc
      spcROLstuff
      WriteByte
      _ret

ALIGN4
NEWSYM Op6C       ; ROR labs  C >> (abs)  <<C       N......ZC
      mov bx,[ebp]
      add ebx,spcRam
      add ebp,2
      test byte [spcP],01h
      jnz near Op6Cb
      ReadByte2
      clc
      spcRORstuff
      WriteByte
      _ret
ALIGN4
NEWSYM Op6Cb
      ReadByte2
      stc
      spcRORstuff
      WriteByte
      _ret

ALIGN4
NEWSYM Op3C       ; ROL A  C << A      <<C       N......ZC
      test byte [spcP],01h
      jnz near Op3Cb
      clc
      rcl dl,1
      mov al,dl
      jc .setcarryflag
      and byte[spcP],0FEh
      mov [spcNZ],al
      _ret
ALIGN4
.setcarryflag
      or byte[spcP],01h
      mov [spcNZ],al
      _ret
ALIGN4
NEWSYM Op3Cb
      stc
      rcl dl,1
      mov al,dl
      jc .setcarryflag
      and byte[spcP],0FEh
      mov [spcNZ],al
      _ret
ALIGN4
.setcarryflag
      or byte[spcP],01h
      mov [spcNZ],al
      _ret

ALIGN4
NEWSYM Op7C       ; ROR A  C >> A      <<C       N......ZC
      test byte [spcP],01h
      jnz near Op7Cb
      clc
      rcr dl,1
      mov al,dl
      jc .setcarryflag
      and byte[spcP],0FEh
      mov [spcNZ],al
      _ret
ALIGN4
.setcarryflag
      or byte[spcP],01h
      mov [spcNZ],al
      _ret
ALIGN4
NEWSYM Op7Cb
      stc
      rcr dl,1
      mov al,dl
      jc .setcarryflag
      and byte[spcP],0FEh
      mov [spcNZ],al
      _ret
ALIGN4
.setcarryflag
      or byte[spcP],01h
      mov [spcNZ],al
      _ret

;************************************************
; INC/DEC instructions (Verified)
;************************************************

ALIGN4
NEWSYM Op8B       ;  DEC dp   -- (dp)               N......Z.
      mov bl,[ebp]
      add ebx,[spcRamDP]
      inc ebp
      ReadByte2
      dec al
      mov [spcNZ], al
      WriteByte
      _ret

ALIGN4
NEWSYM OpAB       ; INC dp    ++ (dp)               N......Z.
      mov bl,[ebp]
      add ebx,[spcRamDP]
      inc ebp
      ReadByte2
      inc al
      mov [spcNZ], al
      WriteByte
      _ret

ALIGN4
NEWSYM Op9B       ;  DEC dp+X -- (dp+X)             N......Z.
      mov bl,[ebp]
      add bl,[spcX]
      add ebx,[spcRamDP]
      inc ebp
      ReadByte2
      dec al
      mov [spcNZ], al
      WriteByte
      _ret

ALIGN4
NEWSYM OpBB       ; INC dp+X  ++ (dp+X)             N......Z.
      mov bl,[ebp]
      add bl,[spcX]
      add ebx,[spcRamDP]
      inc ebp
      ReadByte2
      inc al
      mov [spcNZ], al
      WriteByte
      _ret

ALIGN4
NEWSYM Op8C       ; DEC labs  -- (abs)              N......Z.
      mov bx,[ebp]
      add ebx,spcRam
      add ebp,2
      ReadByte2
      dec al
      mov [spcNZ], al
      WriteByte
      _ret

ALIGN4
NEWSYM OpAC       ; INC labs  ++ (abs)              N......Z.
      mov bx,[ebp]
      add ebx,spcRam
      add ebp,2
      ReadByte2
      inc al
      mov [spcNZ], al
      WriteByte
      _ret

ALIGN4
NEWSYM Op9C       ; DEC A  -- A                  N......Z.
      dec dl
      mov [spcNZ],dl
      _ret

ALIGN4
NEWSYM OpBC       ; INC A  ++ A                  N......Z.
      inc dl
      mov [spcNZ],dl
      _ret

ALIGN4
NEWSYM OpDC       ; DEC Y  -- Y                  N......Z.
      dec dh
      mov [spcNZ],dh
      _ret

ALIGN4
NEWSYM OpFC       ; INC Y  ++ Y                  N......Z.
      inc dh
      mov [spcNZ],dh
      _ret

ALIGN4
NEWSYM Op1D       ; DEC X     -- X                  N......Z.
      dec byte [spcX]
      mov al,byte [spcX]
      mov [spcNZ],al
      _ret

ALIGN4
NEWSYM Op3D       ; INC X     ++ X                  N......Z.
      inc byte [spcX]
      mov al,byte [spcX]
      mov [spcNZ],al
      _ret

;************************************************
; PUSH/POP instructions (Verified)
;************************************************

ALIGN4
NEWSYM Op0D       ; PUSH PSW     push PSW to stack       .........
      mov eax,[spcS]
      mov bl,[spcP]
      and bl,01111101b
      test byte [spcNZ],80h
      jnz .NegSet
      cmp byte [spcNZ],0
      je near .ZeroSet
      dec byte [spcS]
      mov [spcRam+eax],bl
      _ret
ALIGN4
.NegSet
      or bl,80h
      dec byte [spcS]
      mov [spcRam+eax],bl
      _ret
ALIGN4
.ZeroSet
      or bl,02h
      dec byte [spcS]
      mov [spcRam+eax],bl
      _ret

ALIGN4
NEWSYM Op2D       ; PUSH A       push A to stack         .........
      mov eax,[spcS]
      dec byte [spcS]
      mov [spcRam+eax],dl
      _ret

ALIGN4
NEWSYM Op4D       ; PUSH X       push X to stack         .........
      mov eax,[spcS]
      mov bl,[spcX]
      dec byte [spcS]
      mov [spcRam+eax],bl
      _ret
   
ALIGN4
NEWSYM Op6D       ; PUSH Y    push Y to stack         .........
      mov eax,[spcS]
      dec byte [spcS]
      mov [spcRam+eax],dh
      _ret

ALIGN4
NEWSYM Op8E       ; POP PSW   pop PSW from stack     (Restored)
      inc byte [spcS]
      mov eax,[spcS]
      mov byte [spcNZ],0
      mov bl,[spcRam+eax]
      mov [spcP],bl
      test byte [spcP],2
      jnz .ZeroYes
      mov byte [spcNZ],1
      test byte [spcP],80h
      jz .NoNeg
      or byte [spcNZ],80h
.NoNeg
.ZeroYes
      mov dword [spcRamDP],spcRam
      test byte[spcP],32
      jnz .setpage1
      _ret
ALIGN4
.setpage1
      add dword [spcRamDP],100h
      _ret

ALIGN4
NEWSYM OpAE       ; POP A     pop A from stack        .........
      inc byte [spcS]
      mov eax,[spcS]
      mov dl,[spcRam+eax]
      _ret

ALIGN4
NEWSYM OpCE       ; POP X     pop X from stack        .........
      inc byte [spcS]
      mov eax,[spcS]
      mov bl,[spcRam+eax]
      mov [spcX],bl
      _ret

ALIGN4
NEWSYM OpEE       ; POP Y     pop Y from stack        .........
      inc byte [spcS]
      mov eax,[spcS]
      mov dh,[spcRam+eax]
      _ret

;************************************************
; Test & set bits Instructions (Verified?)
;************************************************

ALIGN4
NEWSYM Op0E       ; TSET1 labs   test and set bits with A   N......Z.
      mov bx,[ebp]
      add ebx,spcRam
      add ebp,2
      ReadByte2
      mov ah,al
      and ah,dl
      mov [spcNZ],ah
      or al,dl
      WriteByte
      _ret

ALIGN4
NEWSYM Op4E       ; TCLR1     test and clear bits with A N......Z.
      mov bx,[ebp]
      add ebx,[spcRamDP]
      add ebp,2
      ReadByte2
      mov ah,al
      and ah,dl
      mov [spcNZ],ah
      mov ah,dl
      not ah
      and al,ah
      WriteByte
      _ret

;************************************************
; Compare/Decrement & Branch Instructions (Verified)
;************************************************

ALIGN4
NEWSYM Op2E       ; CBNE dp,rel  compare A with (dp) then BNE   ...
      mov bl,[ebp]
      add ebx,[spcRamDP]
      ReadByte2
      cmp dl, al
      jne .Jump
      add ebp,2
      _ret
ALIGN4
.Jump
	  add edi,100h
      movsx ebx,byte [ebp+1]
      add ebp,ebx
      add ebp,2
      _ret

ALIGN4
NEWSYM OpDE       ; CBNE dp+X,rel   compare A with (dp+X) then BNE ...
      mov bl,[ebp]
      add bl,[spcX]
      add ebx,[spcRamDP]
      ReadByte2
      cmp dl, al
      jne .Jump
      add ebp,2
      _ret
ALIGN4
.Jump
      add edi,100h
      movsx ebx,byte [ebp+1]
      add ebp,ebx
      add ebp,2
      _ret

ALIGN4
NEWSYM Op6E       ; DBNZ   decrement memory (dp) then JNZ ...
      mov bl,[ebp]
      add ebx,[spcRamDP]
      ReadByte2
      dec al
      jnz .Jump
      add ebp,2
      WriteByte
      _ret
ALIGN4
.Jump
NEWSYM Op6Eb
      push ebx
      add edi,100h
      movsx ebx,byte [ebp+1]
      add ebp,ebx
      add ebp,2
      pop ebx
      WriteByte
      _ret

ALIGN4
NEWSYM OpFE       ; DBNZ Y,rel   decrement Y then JNZ           ...
      dec dh
      jnz .Jump
      inc ebp
      _ret
ALIGN4
.Jump
      add edi,100h
      movsx ebx,byte [ebp]
      add ebp,ebx
      inc ebp
      _ret

;************************************************
; Jump/Subroutine Instructions
;************************************************

ALIGN4
NEWSYM Op0F       ; BRK       software interrupt       ...1.0.. 
;      inc dword[spc700read]
      dec ebp
      _ret

ALIGN4
NEWSYM Op1F       ; JMP (labs+X)    PC <- (abs+X+1)(abs+X)         ...
      mov bx,[ebp]
      add bx,[spcX]
      xor eax,eax
      add ebp,2
      mov ax, word [spcRam+ebx]
      mov ebp,spcRam
      add ebp,eax
      _ret

ALIGN4
NEWSYM Op3F       ; CALL labs    subroutine call          ........
      ; calculate PC
      mov ecx,ebp
      add ecx,2
      sub ecx,spcRam
      mov eax,[spcS]
      mov [spcRam+eax],ch
      dec byte [spcS]
      mov eax,[spcS]
      mov [spcRam+eax],cl
      dec byte [spcS]
      ; set new PC
      mov cx,[ebp]
      add ecx,spcRam
      mov ebp,ecx
      xor ecx,ecx
      _ret

ALIGN4
NEWSYM Op4F       ; PCALL upage  upage call               ........ 
      ; calculate PC
      mov ecx,ebp
      inc ecx
      sub ecx,spcRam
      mov eax,[spcS]
      mov [spcRam+eax],ch
      dec byte [spcS]
      mov eax,[spcS]
      mov [spcRam+eax],cl
      dec byte [spcS]
      ; set new PC
      xor ecx,ecx
      mov cl,[ebp]
      add ecx,spcRam
      add ecx,0ff00h
      mov ebp,ecx
      xor ecx,ecx
      _ret

; I'm not sure about this one and JMP labs+X...

ALIGN4
NEWSYM Op5F       ; JMP labs     jump to new location           ...
      mov bx,[ebp]
      add ebp,2
      mov ebp,spcRam
      add ebp,ebx
      _ret

ALIGN4
NEWSYM Op6F       ; ret          ret from subroutine   ........
      xor ecx,ecx
      inc byte [spcS]
      mov eax,[spcS]
      mov cl,[spcRam+eax]
      inc byte [spcS]
      mov eax,[spcS]
      mov ch,[spcRam+eax]
      add ecx,spcRam
      mov ebp,ecx
      xor ecx,ecx
      _ret

ALIGN4
NEWSYM Op7F       ; ret1         return from interrupt   (Restored)
      dec ebp
      _ret
%if 0 ;wtf?
      xor ecx,ecx
      inc byte [spcS]
      mov eax,[spcS]
      mov cl,[spcRam+eax]
      mov [spcP],cl
      test byte [spcP],80h
      jz .NoNeg
      or byte [spcNZ],80h      
.NoNeg
      test byte [spcP],2
      jz .NoZero
      mov byte [spcNZ],0
      jmp .YesZero
.NoZero
      or byte [spcNZ],1
.YesZero
      inc byte [spcS]
      mov eax,[spcS]
      mov cl,[spcRam+eax]
      inc byte [spcS]
      mov eax,[spcS]
      mov ch,[spcRam+eax]
      add ecx,spcRam
      mov ebp,ecx
      ; set direct page
      mov dword [spcRamDP],spcRam
      test byte[spcP],32
      jz .nodp
      add dword [spcRamDP],100h
.nodp
      xor ecx,ecx
      _ret
%endif
;************************************************
; Divide/Multiply Instructions
;************************************************

ALIGN4
NEWSYM Op9E       ; DIV YA,X     Q:A B:Y <- YA / X       NV..H..Z.
   ;push edx
   mov ax,dx
   xor bh,bh
   xor dx,dx
   mov bl,[spcX]
   cmp bl,0
   je NoDiv
   div bx
   mov dh,dl
   cmp ah,0
   mov dl,al
   jne near Over
   and byte [spcP],191-16
   ;pop edx
   mov [spcNZ],al
   _ret

ALIGN4
NEWSYM NoDiv
   mov dx,0ffffh
   ;mov dl,0ffh
   ;mov dh,0ffh
   or byte [spcP],16
   and byte[spcP],255-64
;   pop edx
   _ret
ALIGN4
NEWSYM Over
   or byte [spcP],64
   and byte[spcP],255-16
;   pop edx
   mov [spcNZ],al
   _ret

ALIGN4
NEWSYM OpCF       ; MUL YA       YA(16 bits) <- Y * A    N......Z.
      mov al,dl
      mul dh
	  mov dx,ax
      ;mov dl,al
      ;mov dh,ah
      ; ??? (Is the n flag set on YA or A?)
      test ax,8000h
      jnz .YesNeg
      cmp ax,0000h
      je .YesZero
      mov byte [spcNZ],1
      _ret
ALIGN4
.YesNeg
      mov byte [spcNZ],80h
      _ret
ALIGN4
.YesZero
      mov byte [spcNZ],0
      _ret

;************************************************
; Decimal Operations
;************************************************

ALIGN4
NEWSYM OpBE       ; DAS A     decimal adjust for sub  N......ZC
;      _ret
      ; copy al flags into AH
      xor ah,ah
      test byte[spcNZ],80h
      jz .noneg
      or ah,10000000b
.noneg
      test byte[spcP],01h
      jz .nocarry
      or ah,00000001b
.nocarry
      test byte[spcNZ],0FFh
      jnz .nozero
      or ah,01000000b
.nozero
      test byte[spcP],08h
      jz .nohcarry
      or ah,00010000b
.nohcarry
      mov al,dl
      sahf
      das
      mov dl,al
      SPCSetFlagnzc

;spcNF    db 0     ; The Negative Flag  128 or 127
;spcOF    db 0     ; The Overflow Flag   64 or 191
;spcDPF   db 0     ; Direct Page Flag    32 or 223
;spcUF    db 0     ; The Unused Flag ?   16 or 239
;spcHCF   db 0     ; The Half Carry Flag  8 or 247
;spcIF    db 0     ; The interrupt flag   4 or 251
;spcZF    db 0     ; The Zero Flag        2 or 253
;spcCF    db 0     ; The Carry Flag       1 or 254

ALIGN4
NEWSYM OpDF       ; DAA A        decimal adjust for add  N......ZC
      ; copy al flags into AH
      xor ah,ah
      test byte[spcNZ],80h
      jz .noneg
      or ah,10000000b
.noneg
      test byte[spcP],01h
      jz .nocarry
      or ah,00000001b
.nocarry
      test byte[spcNZ],0FFh
      jnz .nozero
      or ah,01000000b
.nozero
      test byte[spcP],08h
      jz .nohcarry
      or ah,00010000b
.nohcarry
      mov al,dl
      sahf
      daa
      mov dl,al
      SPCSetFlagnzc

ALIGN4
NEWSYM Invalidopcode ; Invalid Opcode
      dec ebp
      _ret

SECTION .data
ALIGN32

; feel free to copy these to ZSNES :P

NEWSYM opcjmptab
      dd Op00,Op01,Op02,Op03,Op04,Op05,Op06,Op07,Op08,Op09,Op0A,Op0B,Op0C,Op0D,Op0E,Op0F
      dd Op10,Op11,Op12,Op13,Op14,Op15,Op16,Op17,Op18,Op19,Op1A,Op1B,Op1C,Op1D,Op1E,Op1F
	  dd Op20,Op21,Op22,Op23,Op24,Op25,Op26,Op27,Op28,Op29,Op2A,Op2B,Op2C,Op2D,Op2E,Op2F
      dd Op30,Op31,Op32,Op33,Op34,Op35,Op36,Op37,Op38,Op39,Op3A,Op3B,Op3C,Op3D,Op3E,Op3F
      dd Op40,Op41,Op42,Op43,Op44,Op45,Op46,Op47,Op48,Op49,Op4A,Op4B,Op4C,Op4D,Op4E,Op4F
      dd Op50,Op51,Op52,Op53,Op54,Op55,Op56,Op57,Op58,Op59,Op5A,Op5B,Op5C,Op5D,Op5E,Op5F
      dd Op60,Op61,Op62,Op63,Op64,Op65,Op66,Op67,Op68,Op69,Op6A,Op6B,Op6C,Op6D,Op6E,Op6F
      dd Op70,Op71,Op72,Op73,Op74,Op75,Op76,Op77,Op78,Op79,Op7A,Op7B,Op7C,Op7D,Op7E,Op7F
      dd Op80,Op81,Op82,Op83,Op84,Op85,Op86,Op87,Op88,Op89,Op8A,Op8B,Op8C,Op8D,Op8E,Op8F
      dd Op90,Op91,Op92,Op93,Op94,Op95,Op96,Op97,Op98,Op99,Op9A,Op9B,Op9C,Op9D,Op9E,Op9F
      dd OpA0,OpA1,OpA2,OpA3,OpA4,OpA5,OpA6,OpA7,OpA8,OpA9,OpAA,OpAB,OpAC,OpAD,OpAE,OpAF
      dd OpB0,OpB1,OpB2,OpB3,OpB4,OpB5,OpB6,OpB7,OpB8,OpB9,OpBA,OpBB,OpBC,OpBD,OpBE,OpBF
      dd OpC0,OpC1,OpC2,OpC3,OpC4,OpC5,OpC6,OpC7,OpC8,OpC9,OpCA,OpCB,OpCC,OpCD,OpCE,OpCF
      dd OpD0,OpD1,OpD2,OpD3,OpD4,OpD5,OpD6,OpD7,OpD8,OpD9,OpDA,OpDB,OpDC,OpDD,OpDE,OpDF
      dd OpE0,OpE1,OpE2,OpE3,OpE4,OpE5,OpE6,OpE7,OpE8,OpE9,OpEA,OpEB,OpEC,OpED,OpEE,OpEF
      dd OpF0,OpF1,OpF2,OpF3,OpF4,OpF5,OpF6,OpF7,OpF8,OpF9,OpFA,OpFB,OpFC,OpFD,OpFE,OpFF


NEWSYM spcWptr
	dd SPCRegF0,SPCRegF1,SPCRegF2,SPCRegF3
	dd SPCRegF4,SPCRegF5,SPCRegF6,SPCRegF7
	dd SPCRegF8,SPCRegF9,SPCRegFA,SPCRegFB
	dd SPCRegFC,SPCRegFD,SPCRegFE,SPCRegFF
NEWSYM spcRptr
	dd RSPCRegXX,RSPCRegXX,RSPCRegXX,RSPCRegXX
	dd RSPCRegXX,RSPCRegXX,RSPCRegXX,RSPCRegXX
	dd RSPCRegXX,RSPCRegXX,RSPCRegXX,RSPCRegXX
	dd RSPCRegXX,RSPCRegFD,RSPCRegFE,RSPCRegFF

NEWSYM Spc700AsmEnd