#include <windows.h>
#include "common.h"
#include "zsnes.h"
#include "kmp_pi.h"


static HINSTANCE g_hDll; // DLL ̃CX^X
static UINT g_size; // Render ֐̈̏TCY
static BYTE g_buf[0x10200]; // SPC f[^̃obt@
static ZSNES_CONFIG g_config; // ݒ

// filename ̊gq ext ɒu
static void ReplaceExt(char *filename, const char *ext)
{
	size_t i, len1, len2;

	len1 = lstrlen(filename);
	len2 = lstrlen(ext);
	if (len1 == 0 || len2 == 0)
	{
		return;
	}

	for (i=0; i<len2; i++)
	{
		filename[len1-len2+i] = ext[i];
	}
}

// Ȃ̎g擾
static DWORD GetFreq(DWORD rate)
{
	// ȉ̂R̂̂ǂꂩ kb Ŏw肳Ă΂̒lōēxݒ
	if (rate == 23900 || rate == 44100 || rate == 48000)
	{
		g_config.MixingFrequency = rate;
		zsnes_setconfig(&g_config);
	}

	return g_config.MixingFrequency;
}

// Ȃ̒擾
static DWORD GetLength()
{
	char temp[4];
	DWORD len;

	// ID666 wb_Ȃ̒擾
	temp[0] = g_buf[0xa9]; // S̈
	temp[1] = g_buf[0xaa]; // \̈
	temp[2] = g_buf[0xab]; // ̈
	temp[3] = '\0';
	len = atoi(temp) * 1000;

	return (len == 0) ? 0xffffffff : len; // len  0 Ȃs\ 0xffffffff Ԃ
}

static void WINAPI kmp_Init(void)
{
	char filename[MAX_PATH];
	DWORD rate;
	BYTE interp;
	BYTE lowpass;
	BYTE surround;

	// INIt@C
	GetModuleFileName(g_hDll, filename, MAX_PATH);
	ReplaceExt(filename, "ini");

	// ݒǂݍ
	rate = GetPrivateProfileInt("config", "rate", 44100, filename);
	interp = GetPrivateProfileInt("config", "interp", 2, filename);
	lowpass = GetPrivateProfileInt("config", "lowpass", 3, filename);
	surround = GetPrivateProfileInt("config", "surround", 1, filename);

	g_config.RevStereo = 0;
	g_config.SoundInterpType = interp;
	g_config.LowPassFilter = lowpass;
	g_config.Surround = surround;
	g_config.SoundNoiseDis = 0;
	g_config.MixingFrequency = rate;
	g_config.NoSpeedHack = 0;
	g_config.Refresh = REFRESH;

	zsnes_setconfig(&g_config);
}

/*static void WINAPI kmp_Deinit()
{
}*/

static HKMP WINAPI kmp_Open(const char *cszFileName, SOUNDINFO *pInfo)
{
	HANDLE hFile;
	DWORD dwBytes;
	BOOL result;

	hFile = CreateFile(cszFileName, GENERIC_READ, FILE_SHARE_READ, 0,
		OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
	if (hFile == INVALID_HANDLE_VALUE)
	{
		return 0;
	}

	result = ReadFile(hFile, g_buf, sizeof(g_buf), &dwBytes, 0);
	CloseHandle(hFile);
	if (result == FALSE)
	{
		return 0;
	}

	pInfo->dwSamplesPerSec = GetFreq(pInfo->dwSamplesPerSec);
	g_size = (MixingRate/REFRESH)<<2;

	pInfo->dwBitsPerSample = 16; // 16bit
	pInfo->dwChannels = 2; // XeI
	pInfo->dwLength = GetLength();
	pInfo->dwSeekable = 0;
	pInfo->dwUnitRender = g_size;
	pInfo->dwReserved1 = 1;
	pInfo->dwReserved2 = 0;

	// ̌ SetPosition Ă΂̂łČĂ΂Ȃ
	//zsnes_setup(g_buf);

	return (HKMP)1;
}

static void WINAPI kmp_Close(HKMP hKMP)
{
}

static DWORD WINAPI kmp_Render(HKMP hKMP, BYTE* Buffer, DWORD dwSize)
{
	UINT i, size;

	size = 0;

	if (hKMP == (HKMP)1)
	{
		if (dwSize == g_size)
		{
			size = zsnes_doframe(Buffer);
		}
		else // dwSize  g_size ̔{nꂽƂ
		{
			for (i=0; i<(dwSize/g_size); i++)
			{
				size += zsnes_doframe(Buffer+size);
			}
		}
	}

	return size;
}

static DWORD WINAPI kmp_SetPosition(HKMP hKMP, DWORD dwPos)
{
	if (dwPos == 0)
	{
		zsnes_setup(g_buf);
	}

	return 0;
}

BOOL APIENTRY DllMain(HANDLE hModule, DWORD fdwReason, LPVOID lpvReserved)
{
	switch (fdwReason)
	{
	case DLL_PROCESS_ATTACH:
		g_hDll = hModule; // ŎgO[oϐɕۑ
		break;
	case DLL_PROCESS_DETACH:
		if (echobuf)
		{
			echobuf = (DWORD)LocalFree((HLOCAL)echobuf);
		}
		break;
	}

	return TRUE;
}

KMPMODULE *WINAPI kmp_GetTestModule()
{
	char filename[MAX_PATH];
	int isSPNSupport;

	static const char *ppszSupportExts[] = { ".spc", 0 };
	static KMPMODULE mod = 
	{
		KMPMODULE_VERSION,
		110,
		"Copyright (C) 2002 ZSNES team, Peter Pawlowski, Arisugawa",
		"ZSNES core SPC Plugin for KbMedia Player",
		ppszSupportExts,
		0,
		kmp_Init,
		0,/*kmp_Deinit*/
		kmp_Open,
		0,
		kmp_Close,
		kmp_Render,
		kmp_SetPosition,
	};

	// INIt@C
	GetModuleFileName(g_hDll, filename, MAX_PATH);
	ReplaceExt(filename, "ini");

	// ݒǂݍ
	isSPNSupport = GetPrivateProfileInt("config", "SPNSupport", 0, filename);
	if (isSPNSupport) // .sp1  .sp9 T|[g
	{
		static const char *ppszSupportExts2[] = { ".spc",
			".sp1", ".sp2", ".sp3", ".sp4", ".sp5", ".sp6", ".sp7", ".sp8", ".sp9", 0 };
		mod.ppszSupportExts = ppszSupportExts2;
	}

	return &mod;
}