#include <windows.h>
#include "common.h"

/*

this module (zsnes.c) copyright (C) 2001 Peter Pawlowski (peterpw666@hotmail.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/
#define BYTE unsigned char
#define WORD unsigned short
#define DWORD unsigned long
#define UINT unsigned int

static UINT qual_tab[7]={8000,11025,22050,44100,16000,32000,48000};

#include "zsnes.h"

static UINT dll_version=3;

DWORD cyclesperline=256;//2048 mhz

BYTE RevStereo=0;
BYTE cfgecho=0;
BYTE StereoSound=1;
BYTE SoundInterpType=2;
BYTE LowPassFilterType=3;
BYTE Surround=0;
BYTE SoundNoiseDis=0;
BYTE SpeedHack=1;

extern DWORD CEchoPtr, EchoRate[16];

void postSPCload();//safe to call w/o asmhacks

extern DWORD spcPCRam,spcRamDP;
extern DWORD spcA,spcX,spcY,spcP;
extern BYTE spcS,spcNZ,timeron,timincr0,timincr1,timincr2;
extern BYTE spcRam[],spcextraram[],DSPMem[];
extern BYTE Voice0Disable[8];

static UINT frames;
void setnoise();
void AdjustFrequency();

static UINT total_written;
void onetime_init();
void reset_mini();

static void alloc_echo()
{
	UINT echo_size = (EchoRate[15] * (StereoSound ? 2 : 1) * 4);

	if (!echobuf)
		echobuf = (DWORD)LocalAlloc(LMEM_FIXED | LMEM_ZEROINIT, echo_size);
	else
		echobuf = (DWORD)LocalReAlloc((HLOCAL)echobuf,echo_size,LMEM_MOVEABLE | LMEM_ZEROINIT);

	memset((void*)echobuf,0,echo_size);
	CEchoPtr=echobuf;

}

void zsnes_setup(void * image)
{
	BYTE * i;
	UINT n;

	onetime_init();

	if (!echobuf) 
	{
		//whoops
		_asm
		{
			pushad
			call AdjustFrequency
			popad
		}

		alloc_echo();
	}

	i=(BYTE*)image;
	spcPCRam = *(WORD*)(i+37);
	spcA=i[39];
	spcX=i[40];
	spcY=i[41];
	spcP=i[42];
	spcS=i[43];

	spcNZ=0;

	if (spcP&0x80)
	{
		spcNZ|=0x80;
		spcP&=0x7F;
	}
	if (!(spcP&2))
	{
		spcNZ|=0x7F;
	}
	spcP&=0xFD;

	spcRamDP=0;
	

	memcpy(spcRam,i+0x100,0x10000);
	memcpy(DSPMem,i+0x10100,0x80);
	memcpy(spcextraram,i+0x100C0,0x40);

	
	for(n=0;n<8;n++) Voice0Disable[n]=1;
	
	
	postSPCload();

	total_written=0;
	frames=0;


}

extern DWORD BufferSizeB,BufferSizeW;

void ProcessSoundBuffer();

extern long DSPBuffer[];

void StartSPC();

DWORD totlines=80;	//8khz clock ticks per refresh, NOT SCANLINES


int muldiv(int foo,int foo1,int foo2);
//#define muldiv(foo,foo1,foo2) (((foo) * (foo1)) / (foo2))
// ^^ $#@! do not uncomment

void (__fastcall* downmix_func)(UINT,void*);

// void downmix_func(void*,UINT dsam);//dsam = no. of dwords/qwords

UINT zsnes_doframe(void * out)	//returns number of bytes written to buffer
{
	UINT nsam,dsam,n;
	short * o;
	if (!out) return ((MixingRate/REFRESH)<<2)+64;//mmx shit

	StartSPC();

	frames++;
	o=(short*)out;

	nsam=muldiv(frames,MixingRate,REFRESH) - total_written;

	total_written+=nsam;
	while(nsam)
	{
		dsam=320*2;
		if (dsam>nsam) dsam=nsam;
		BufferSizeB=dsam<<1;
		BufferSizeW=dsam<<2;
		_asm
		{
			pushad
			call ProcessSoundBuffer
			popad
		}

		if (Surround)
		{
			for(n=0;n<dsam<<1;)
			{
				int foo=DSPBuffer[n++];
				if (foo>0x7FFF) foo=0x7FFF;
				else if (foo<-0x8000) foo=-0x8000;
				*(o++)=(short)foo;
				foo=-DSPBuffer[n++];
				if (foo>0x7FFF) foo=0x7FFF;
				else if (foo<-0x8000) foo=-0x8000;
				*(o++)=(short)foo;
			}

		}
		else
		{
			downmix_func(dsam,o);//dsam = no. of dwords/qwords
			o+=dsam<<1;
/*			for(n=0;n<dsam<<1;n++)
			{
				int foo=DSPBuffer[n];
				if (foo>0x7FFF) foo=0x7FFF;
				else if (foo<-0x8000) foo=-0x8000;
				*(o++)=(short)foo;
			}*/
		}

		nsam-=dsam;
	}
	return (BYTE*)o-(BYTE*)out;	
}


void zsnes_seek(void * image,UINT ms,char * kill)
{
	UINT dest_frames = muldiv(ms,REFRESH,1000);
	if (dest_frames<frames)
	{
		zsnes_setup(image);
	}
	while(frames<dest_frames && !*kill)
	{
		StartSPC();
		frames++;
	}
	total_written=muldiv(frames , MixingRate,REFRESH);
}



void zsnes_setconfig(ZSNES_CONFIG* c)
{
	RevStereo=c->RevStereo;
	SoundInterpType=c->SoundInterpType;
	LowPassFilterType=c->LowPassFilter;
	Surround=c->Surround;
	SoundNoiseDis=c->SoundNoiseDis;
	MixingRate=c->MixingFrequency;
	SpeedHack=c->NoSpeedHack ? 0 : 1;
	refresh=c->Refresh;

	frames=muldiv(total_written,refresh,MixingRate);

	totlines=(8000+(refresh>>1))/refresh;
	
	_asm
	{
		pushad
		call AdjustFrequency
		call reset_mini
		popad
	}

	if (dll_version>=4)
	{
		if (c->SpeedMultiplier!=0 && c->SpeedMultiplier<=8)
			cyclesperline=128 * c->SpeedMultiplier;
	}

	alloc_echo();
}

UINT zsnes_dllversion() {return 3;}//old-style, use zsnes_dllversion2 instead

BOOL zsnes_dllversion2(UINT v)
{//return if we are compatible with version v; set internal compatibility flags
	if (v!=3 && v!=4) return 0;
	dll_version=v;
	return 1;
}

extern BYTE MuteVoiceF;
extern BYTE Voice0Disable[8];

void zsnes_setmute(BYTE flags)
{
	UINT n;
	MuteVoiceF=flags;	
	for(n=0;n<8;n++)
	{
		Voice0Disable[n]=((flags>>n)&1)^1;
	}
}